****************************************************************************
* Arquivo...: click.prg
* Definicao.: Click! is a Clipper/Xbase++ source code reformatter.
* Versao....: 3.01 HMG
* Observacao: 
****************************************************************************
*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/click.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Procedure click()
*+               STATIC Function afront()
*+               STATIC Function bReadPart()
*+               Procedure centertext()
*+               Init Procedure CLIPINIT()
*+               STATIC Function dbc_identify()
*+               Procedure ERRORSYS()
*+               STATIC Procedure exitproc()
*+               STATIC Function func_head()
*+               STATIC Function IndentLevel()
*+               STATIC Procedure IndentReset()
*+               STATIC Function leadspace()
*+               Function lineparse()
*+               STATIC Procedure main_screen()
*+               STATIC Function pop_stack()
*+               Function RootName()
*+               Procedure setlinecont()
*+               Procedure show_in()
*+               Procedure show_out()
*+               Function TabSpStrip()
*+               Function TabStrip()
*+               STATIC Procedure TheAligner()
*+       Tables: use ( cDBFPath ) //shared
*+               use ( cDBFPath ) exclusive
*+      Indexes: index on click->FNCT+click->SRCE TAG funct_src UNIQUE //added click-> harbour 2/09
*+               index ON click->FNCT+click->SRCE TO (cNSXPath) //added click->harbour 2/09
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
#include "hmg.ch"

#include "directry.ch"
#include "common.ch"
#include "inkey.ch"
#include "fileio.ch"

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
#define CVERSION '3.01 HMG'
#define NewLine  11

*---------------------------------------------------------------------------
* Variaveis staticas
*---------------------------------------------------------------------------
STATIC nLineCount    := 0
STATIC nMasterCount  := 0
STATIC lLineContinue := .F.
STATIC lLastContinue := .F.
STATIC nStripComment := 0
STATIC lCommentMode  := .F.
STATIC oOutHandle, cFuncDiv
STATIC lDumpBuffer   := .F.
STATIC lMoreToGo     := .F.
STATIC aCommand      := {}
STATIC aCmdLogic     := {}
STATIC aFunction     := {}
STATIC cComCase, cFunCase, cBoolCase
STATIC nAlignMethod, nUnCase, nUnFor, nUnSequence
STATIC lVerbose, lMode5, nComntTab, lConvertSlash, lConvertStar
STATIC lConvertArray, lRemDupMTLine
STATIC lGotClass     := .F.
STATIC lDeflate1, lDeflate2, lDeflate3, lDeflate4, lDeflate5
STATIC nTabIf, nIndIf, nTabFor, nIndFor, nTabCase, nIndCase, nTabFunc, nTabContinue
STATIC nIndFunc, nTabBegin, nIndBegin, nTabWhile, nIndWhile, nTabClass
STATIC lRestScrn
STATIC nMidScreen    := 15


****************************************************************************
PROCEDURE click( filespec )   //to about line 1460
****************************************************************************
LOCAL aStack     := {}
LOCAL aFileNames, aParse, aLine, uLine, aType
LOCAL oBuffObj1, oBuffObj2
LOCAL aFileList  := {}
LOCAL aLibList   := {}
LOCAL aNewLine, aNewType, aAss, aTss, aVars, aTars
LOCAL atemp      := {}  //flagship debugging

LOCAL cThisFile, cPathFile, cOutFile, cOrigLine, nOrigLen
LOCAL cThisLine, uThisLine, cHeadText, cLast, cClickini
//local cOSCRLF    := HB_OSNewLine()
LOCAL cOSCRLF
LOCAL cContSpace := ''
LOCAL cDBFPath, cNSXPath, cComment, cOutput, cFirstWord, cErrorText, cThisText
LOCAL cGrab      := ''
LOCAL cHeadDiv, cOutExt, cOutDir, cOutOver, cClickLog, cFullPath
LOCAL dirsep, drivesep

LOCAL x, xx, y
LOCAL nNumFiles, nPointer, nDefIndent, nMaxSmartAlign, nOutPad, nParenCount
LOCAL nFileCount       := 0
LOCAL nFirstNonComment, nPcntDone, nOldPcntDone, nTo, nLineLen
LOCAL ntemp   //nHandle   //harbour conversion

LOCAL lContSpace  := .F.
LOCAL lGrabMore   := .F.
LOCAL lCaseIndent, lClickAdd, lClickEOF, lConvertDo, lDeclBust, lErrNotify
LOCAL lClickFunc, lClickKill, lEraseLog, lFuncIndent, lFileList, lGotFunction, lGotOne
LOCAL lIfCommand, lLinkList, lLocIndent, lMultKill, lRepl2Assign, lRetTimeDate
LOCAL lSkipFiles, lSnapKill, lStor2assign, lTheAligner

LOCAL nStartJulian
LOCAL cTemp

LOCAL oBuffSave, lTempFunction, bTempLine, tLine, tType, lOnReturn

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
SET SCOREBOARD off
SET CURSOR off
SET EPOCH TO YEAR( DATE() ) - 50

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
cOSCRLF := HB_OSNEWLINE()
IF CHR( 13 ) + CHR( 10 ) = cOSCRLF  //must be ms based
  dirsep   := '\'
  drivesep := DISKNAME() + ':'
ELSE  //must be linux,chr(10) or mac chr(13)
  dirsep   := '/'
  drivesep := ''
  //  SET PATH '.;/home/paul/click')
ENDIF
cFullPath := drivesep + dirsep + CURDIR( drivesep ) + dirsep  //10/03 local copy in startup directory
cDBFPath  := cFullPath + 'click.dbf'
cNSXPath  := cFullPath + 'click.ntx'  //5/05 just the name +ordbagext()
cClickini := cFullPath + 'click.ini'
IF .NOT. FILE( cfullpath + 'click.hdr' )   //just default to oscrlf, update if required later
  createhdr( cfullpath + 'click.hdr', cOSCRLF )
ENDIF
IF .NOT. FILE( cClickini )   //if we add click.ini we probably added click.hdr
  createini( cClickini )
  IF verify( { 'click.ini and click.hdr set to default.', ;
              'Do you  wish to edit before proceeding?' }, .f., 'Exit & edit', 'Continue' )
    exitproc()
    QUIT
  ENDIF
ENDIF
cHeadDiv := ProfileString( cClickini, 'CLICK', 'HEAD_DIV', '-' )
cOutExt  := ProfileString( cClickini, 'CLICK', 'OUTPUT_EXTENSION', '.prg' )
cOutDir  := cFullPath + ;
  ProfileString( cClickini, 'CLICK', 'OUTPUT_DIRECTORY', 'clickout' ) + dirsep
ntemp := DIRCHANGE( cOutDir )   //returns 0 if successful

*---------------------------------------------------------------------------
* make sure we have different output directory
*---------------------------------------------------------------------------
DO CASE
*---------------------------------------------------------------------------
* don't allow overwriting current prg files
*---------------------------------------------------------------------------
CASE cFullPath == cOutDir .AND. UPPER( cOutExt ) = '.PRG'
  POP_MSG( { 'Exiting, input directory same as output:', cOutdir }, .T. )
  exitproc()
  QUIT
*---------------------------------------------------------------------------
* successfully changed directory
*---------------------------------------------------------------------------
CASE ntemp = 0
  DIRCHANGE( cFullPath )  //back to original directory
*---------------------------------------------------------------------------
* we failed to change, try creating directory
*---------------------------------------------------------------------------
CASE ntemp <> 0
  ntemp := DIRMAKE( cOutdir )
  *---------------------------------------------------------------------------
  * we failed to create directory
  *---------------------------------------------------------------------------
  IF ntemp <> 0
    POP_MSG( { 'Exiting, failed to create directory, ', cOutdir + ', with error code ' + STR( ntemp, 4, 0 ) }, .T. )
    exitproc()
    QUIT
  ENDIF
ENDCASE

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
cOutOver       := ProfileString( cClickini, 'CLICK', 'OUTPUT_OVERWRITE', 'ASK' )
cClickLog      := ProfileString( cClickini, 'CLICK', 'CLICK_LOG', 'click.log' )
nDefIndent     := ProfileNum( cClickini, 'CLICK', 'DEFAULT_INDENT', 8 )
nMaxSmartAlign := ProfileNum( cClickini, 'CLICK', 'SMART_ALIGN_MAX_ELEMENTS', 11 )
lSnapKill      := ProfileString( cClickini, 'CLICK', 'REMOVE_SNAP_HEADERS', 'YES' ) == 'YES'
lMultKill      := ProfileString( cClickini, 'CLICK', 'REMOVE_MULTIEDIT_HEADERS', 'YES' ) == 'YES'
lClickKill     := ProfileString( cClickini, 'CLICK', 'REMOVE_CLICK_HEADERS', 'YES' ) == 'YES'
lClickAdd      := ProfileString( cClickini, 'CLICK', 'ADD_CLICK_HEADER', 'YES' ) == 'YES'
lClickFunc     := ProfileString( cClickini, 'CLICK', 'ADD_FUNCTION_HEADERS', 'YES' ) == 'YES'
lClickEOF      := ProfileString( cClickini, 'CLICK', 'ADD_EOF_MARKER', 'YES' ) == 'YES'
lErrNotify     := ProfileString( cClickini, 'CLICK', 'NOTIFY_OF_ERROR_ON_SCREEN', 'YES' ) == 'YES'
lEraseLog      := ProfileString( cClickini, 'CLICK', 'CLICK_LOG_ERASE', 'YES' ) == 'YES'
lFuncIndent    := ProfileString( cClickini, 'CLICK', 'INDENT_FUNCTIONS', 'NO' ) == 'YES'
lLocIndent     := ProfileString( cClickini, 'CLICK', 'INDENT_LOCALS', 'NO' ) == 'YES'
lCaseIndent    := ProfileString( cClickini, 'CLICK', 'INDENT_DO_CASE', 'NO' ) == 'YES'
lDeclBust      := ProfileString( cClickini, 'CLICK', 'PREPROCESS_WITH_DECLARATION_BUSTER', 'YES' ) == 'YES'
lTheAligner    := ProfileString( cClickini, 'CLICK', 'POSTPROCESS_WITH_THE_ALIGNER', 'YES' ) == 'YES'
lRepl2Assign   := ProfileString( cClickini, 'CLICK', 'CHANGE_REPLACE_WITH_TO_ASSIGNMENT', 'YES' ) == 'YES'
lStor2Assign   := ProfileString( cClickini, 'CLICK', 'CHANGE_STORE_TO_ASSIGNMENT', 'YES' ) == 'YES'
lRetTimeDate   := ProfileString( cClickini, 'CLICK', 'RETAIN_ORIGINAL_TIME_DATE_ON_OUTPUT_FILES', 'YES' ) == 'YES'
lSkipFiles     := ProfileString( cClickini, 'CLICK', 'SKIP_FILES_WITH_NO_CHANGES', 'YES' ) == 'YES'
lConvertDo     := ProfileString( cClickini, 'CLICK', 'CONVERT_OLD_STYLE_FUNCTIONS', 'NO' ) == 'YES'
//end of group moved from local statements

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
cFuncDiv      := ProfileString( cClickini, 'CLICK', 'FUNC_DIV', '' )
cComCase      := ProfileString( cClickini, 'CLICK', 'CASE_OF_COMMANDS', 'NOCHANGE' )
cFunCase      := ProfileString( cClickini, 'CLICK', 'CASE_OF_FUNCTIONS', 'NOCHANGE' )
cBoolCase     := ProfileString( cClickini, 'CLICK', 'CASE_OF_BOOLEAN', 'NOCHANGE' )
nAlignMethod  := ProfileNum( cClickini, 'CLICK', '@_SAY_GET_ALIGNMENT_METHOD', 1 )
lVerbose      := ProfileString( cClickini, 'CLICK', 'VERBOSE', 'YES' ) == 'YES'
nComntTab     := ProfileNum( cClickini, 'CLICK', 'COMMENTTAB', 10 )
lConvertSlash := ProfileString( cClickini, 'CLICK', 'CONVERT_&&_TO_//', 'YES' ) == 'YES'
lConvertStar  := ProfileString( cClickini, 'CLICK', 'CONVERT_*_TO_//', 'YES' ) == 'YES'
lConvertArray := ProfileString( cClickini, 'CLICK', 'CONVERT_][_TO_,', 'YES' ) == 'YES'
lDeflate1     := ProfileString( cClickini, 'CLICK', 'DEFLATE_(', 'NO' ) == 'YES'
lDeflate2     := ProfileString( cClickini, 'CLICK', 'DEFLATE_[', 'NO' ) == 'YES'
lDeflate3     := ProfileString( cClickini, 'CLICK', 'DEFLATE_{', 'NO' ) == 'YES'
lDeflate4     := ProfileString( cClickini, 'CLICK', 'DEFLATE_,', 'NO' ) == 'YES'
lDeflate5     := ProfileString( cClickini, 'CLICK', 'DEFLATE_+', 'NO' ) == 'YES'

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
nTabIf       := ProfileNum( cClickini, 'CLICK', 'INDENT_IF', 3 )
nIndIf       := 0
nTabFor      := ProfileNum( cClickini, 'CLICK', 'INDENT_FOR', 3 )
nIndFor      := 0
nTabCase     := ProfileNum( cClickini, 'CLICK', 'INDENT_CASE', 3 )
nIndCase     := 0
nTabFunc     := ProfileNum( cClickini, 'CLICK', 'INDENT_FUNC', 3 )
nIndFunc     := 0
nTabBegin    := ProfileNum( cClickini, 'CLICK', 'INDENT_BEGIN', 3 )
nIndBegin    := 0
nTabWhile    := ProfileNum( cClickini, 'CLICK', 'INDENT_WHILE', 3 )
nIndWhile    := 0
nTabClass    := ProfileNum( cClickini, 'CLICK', 'INDENT_CLASS', 3 )
nTabContinue := ProfileNum( cClickini, 'CLICK', 'INDENT_CONTINUE_LINE', 1 )

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
lMode5        := UPPER( ProfileString( cClickini, 'CLICK', 'RUNMODE', '5.X' ) ) == '5.X'
lRestScrn     := UPPER( ProfileString( cClickini, 'CLICK', 'RESTORE_SCREEN_ON_EXIT', 'NO' ) ) == 'YES'
lRemDupMTLine := ProfileString( cClickini, 'CLICK', 'REMOVE_DUPLICATE_EMPTY_LINES', 'YES' ) == 'YES'
IF .NOT. lMode5
  lDeclBust := .F.
ENDIF
DEFAULT filespec TO '*.prg'
putscreen()

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
IF UPPER( filespec ) $ '/REBUILD|/UPDATE|CLICK.DBF'
  main_screen( filespec )
  libread( cDBFPath, cNSXPath, cClickini )
  exitproc()
  QUIT
ENDIF

lFileList := LEFT( filespec, 1 ) == '@'

lLinkList := '.LNK' $ UPPER( filespec )   //probably not a xHarbour thing

IF RootName( filespec ) == filespec
  filespec += '.prg'  //default to lower case prg file
ENDIF

DO CASE
CASE lLinkList
  IF LEFT( filespec, 1 ) == '@'
    filespec := SUBSTR( filespec, 2 )
  ENDIF

  cTemp     := readlnk( filespec )
  aFileList := cTemp[ 1 ]
  aLibList  := cTemp[ 2 ]

CASE lFileList
  aFileList := readlist( SUBSTR( filespec, 2 ), '@' )

OTHERWISE
  aFileNames := DIRECTORY( filespec )
  nNumFiles  := LEN( aFileNames )
  FOR x = 1 TO nNumFiles
    AADD( aFileList, aFileNames[ x, F_NAME ] )
  NEXT x
ENDCASE

aFileList := ASORT( aFileList )

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
nNumFiles := LEN( aFileList )
IF nNumFiles == 0
  CLEAR SCREEN
  ? 'Click! ' + CVERSION
  ?
  ? 'Usage:'
  ?
  ? '    CLICK [ [@]<filename/filespec> ]'
  ?
  ? '       Where:'
  ?
  ? '       <filename> is the name of your link script (myprog.lnk)'
  ? '   or'
  ? '       <filespec> is a legal filespec. Wildcards permitted.'
  ? '                  (myprog.prg) (*.prg)'
  ? '                  Click with no parameters assumes *.prg'
  ? '   or'
  ? '       @<filename> is a text file containing a list of filenames'
  ? '                   (progname.txt)'
  ?
  QUIT
ENDIF

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
main_screen( filespec )
IF .NOT. FILE( cDBFPath )
  IF verify( 'Click! needs to scan your library files.', .t., 'OK', 'Quit' )
    putscreen()
    libread( cDBFPath, cNSXPath, cClickini )
    getscreen()
  ELSE
    DEVPOS( MAXROW() - 2, 0 )
    exitproc()
    QUIT
  ENDIF
ENDIF

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
IF lConvertDo
  IF verify( { 'You have turned on the conversion of DO/WITH', ;
              'to formal function with parameters', ;
              '', ;
              'CONVERT_OLD_STYLE_FUNCTIONS=YES', ;
              '', ;
              'Due to DO/WITH passing the parameters by reference', ;
              'and FUNCTION( PARAMETERS ) not passing by reference,', ;
              'the only way to make the change is to precede all', ;
              'parameters in the parameter list with @', ;
              '', ;
              'This has the potential to cause compiler error C2009', ;
              '', ;
              'To correct the compiler errors, you will have to', ;
              'remove the @ sign when it is not needed in the', ;
              'converted function call and recompile' }, .f., 'Continue', 'Stop' )
  ELSE
    QUIT
  ENDIF
ENDIF

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
DBCLOSEALL()
USE ( cDBFPath ) //shared
IF FILE( cNSXPath )
  SET INDEX TO ( cNSXPath )
ELSE
  DBCLOSEALL()
  USE ( cDBFPath ) EXCLUSIVE
  show_in( 'Creating ' + cNSXPath + ' for ' + cDBFPath )
  INDEX ON click->FNCT + click->SRCE TAG funct_src UNIQUE   //added click-> harbour 2/09
  //don't think funct_src tag is required
  INDEX ON click->FNCT + click->SRCE TO ( cNSXPath )  //added click->harbour 2/09
  DBCLOSEALL()
  USE ( cDBFPath ) //shared
  SET INDEX TO ( cNSXPath )
ENDIF

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
click->( DBSETORDER( 1 ) )
cClickLog := cOutDir + cClickLog
IF lEraseLog
  FERASE( cClickLog )
ENDIF

err_log( cClickLog, '>>>>>> Click! Run Start: ' + DTOS( DATE() ) + ' ' + TIME() )
err_log( cClickLog, '' )

*---------------------------------------------------------------------------
* Initialize the arrays that the program uses to figure out things...
*---------------------------------------------------------------------------
show_in( 'Initializing Arrays from ' + cClickini + ' file' )

aLine     := init_list( cClickini )   // why waste a variable name here???
aCommand  := aLine[ 1 ]   //it sure makes dubugging interesting!
aFunction := aLine[ 2 ]
aCmdLogic := aLine[ 3 ]
op_list( '' )

nStartJulian := td2jul()

*---------------------------------------------------------------------------
* start looping through file list
*---------------------------------------------------------------------------
BEGIN SEQUENCE
  FOR xx = 1 TO nNumFiles  //next around 1335

    cThisFile := afileList[ xx ]

    IF .NOT. FILE( cThisFile )
      LOOP
    ENDIF

    IndentReset()
    cContSpace    := ''
    lContSpace    := .F.
    lCommentMode  := .F.
    lLineContinue := .F.
    lLastContinue := .F.
    nLineCount    := 0
    nStripComment := 0

    @  4,  1 clear TO 4, MAXCOL() - 1

    cPathFile := cFullPath + cThisFile

    centertext( 'Current File => ' + cPathFile, 4 )

    IF UPPER( cOutExt ) == '.PRG' .AND. ( cOutDir == '.' .OR. EMPTY( cOutDir ) )
      pop_msg( { 'You cannot use the .PRG extension', ;
        'unless you direct output to a different directory' } )
      DEVPOS( MAXROW() - 2, 0 )
      exitproc()
      QUIT
    ENDIF

    *---------------------------------------------------------------------------
    * skip files without changes
    *---------------------------------------------------------------------------
    IF lSkipFiles
      cOutFile := cOutDir + RootName( cThisFile ) + cOutExt
      IF FILE( cOutFile )
        IF td2jul( filetime( cOutFile ), filedate( cOutFile ) ) >= ;
                  td2jul( filetime( cPathFile ), filedate( cPathFile ) )
          show_out( 'Skipping ' + cPathFile )
          LOOP
        ENDIF
      ENDIF
    ENDIF

    IF lTheAligner
      cOutFile := '$prealin.tmp'
    ELSE
      cOutFile := cOutDir + RootName( cThisFile ) + cOutExt
    ENDIF

    IF cOutOver <> 'ALWAYS'
      IF FILE( cOutFile )
        IF cOutOver == 'ASK'
          IF .NOT. verify( { 'Output file exists. Overwrite?', '', '<Esc> to end Click!' } )
            IF LASTKEY() == 27
              exitproc()
              QUIT
            ELSE
              LOOP
            ENDIF
          ENDIF
        ELSE
          LOOP
        ENDIF
      ENDIF
    ENDIF

    nFileCount ++

    @  6,  5 clear TO 6, MAXCOL() - 5

    @  6,  5 SAY 'PASS'

    centertext( 'File ' + LTRIM( STR( xx ) ) + ' of ' + LTRIM( STR( nNumFiles ) ), 7 )

    IF lDeclBust
      @  6, 10 SAY '1'  //this strips indents and puts variable delcarations on separate lines
      declbust( cThisFile, '$declbst.tmp', cClickini )
      oBuffObj1 := bInit( '$declbst.tmp' )  //set obuff to this temp file
    ELSE
      oBuffObj1 := bInit( cThisFile )   //set obuff to this original file
    ENDIF
    @  6, 10 SAY '2'
    init_func_text( cThisFile, cClickini )
    nPcntDone := 0
    IF bopen( oBuffObj1 )   //opening $declbst or cthisfile(.prg file)

      FERASE( cOutFile )
      oOutHandle := bo_init( cOutFile, FO_WRITE, oBuffObj1[ newline ], cClickini )
      bo_open( oOutHandle )   //open the output file

      IF lClickAdd
        bo_write( oOutHandle, '*+' + REPLICATE( cHeadDiv, 68 ) + oBuffObj1[ newline ] )
        bo_write( oOutHandle, '*+' + oBuffObj1[ newline ] )
        bo_write( oOutHandle, '*+    Source Module => ' + cFullPath + cThisFile + oBuffObj1[ newline ] )
        oBuffObj2 := {}
        oBuffObj2 := bInit( 'click.hdr',, )
        IF .NOT. EMPTY( oBuffObj2 )
          bo_write( oOutHandle, '*+' + oBuffObj1[ newline ] )
          IF bopen( oBuffObj2 )
            DO WHILE !beof( oBuffObj2 )   //write will match whatever is in original file
              bo_write( oOutHandle, '*+    ' + bReadLine( oBuffObj2 ) + oBuffObj1[ newline ] )
              @  6, 67 SAY STR( bLineNumber( oBuffObj2 ), 8 )
            ENDDO
          ENDIF
          bclose( oBuffObj2 )
        ENDIF

        bo_write( oOutHandle, '*+' + oBuffObj1[ newline ] )
        bo_write( oOutHandle, '*+    Reformatted by Click! ' + CVERSION + ' on ' + nicedate( DATE() ) + ' at ' + am_pm( TIME() ) + oBuffObj1[ newline ] )
        bo_write( oOutHandle, '*+' + oBuffObj1[ newline ] )
        bo_write( oOutHandle, '*+' + REPLICATE( cHeadDiv, 68 ) + oBuffObj1[ newline ] )
        IF .NOT. lRemDupMTLine   //3/06 comment out ??
          bo_write( oOutHandle, oBuffObj1[ newline ] )
        ENDIF
      ENDIF

      DO WHILE !beof( oBuffObj1 ) .OR. lMoreToGo  //end of loop ~1340

        nOldPcntDone := nPcntDone
        nPcntDone    := INT( bRelative( oBuffObj1 ) * 50 )  //return percent processed
        IF nOldPcntDone <> nPcntDone
          @  6, 14 SAY REPLICATE( '', nPcntDone ) COLOR 'GB+/B'
        ENDIF
        aParse    := bReadPart( oBuffObj1 )   //read line from buffer pass it to parser
        aLine     := aParse[ 1 ]  //all columns of row one
        aType     := aParse[ 2 ]  //all columns of row two
        cOrigLine := aParse[ 3 ]  //all columns of row three
        nLineLen  := LEN( aLine )
        IF lGrabMore
          lGrabMore := .F.
          cOrigLine := cGrab + cOrigLine
          aParse    := lineparse( cOrigLine )
          aLine     := aParse[ 1 ]
          aType     := aParse[ 2 ]
        ELSE
          lGrabMore := .F.
          IF nlineLen == 3
            IF UPPER( aLine[ 1 ] ) == 'DO' .AND. aLine[ 3 ] == ';'
              lGrabMore := .T.
              cGrab     := aLine[ 1 ] + ' '
              LOOP
            ENDIF
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * does the user want out?
        *---------------------------------------------------------------------------
        IF INKEY() == 27
          BREAK
        ENDIF

        *---------------------------------------------------------------------------
        * if lastcontinue was true at this point and an * is
        * first should be a multiply but becomes a comment
        *---------------------------------------------------------------------------
        lLastContinue := lLineContinue
        lLineContinue := ASCAN( aType, 'LC' ) > 0

        *---------------------------------------------------------------------------
        * Blow past empty lines
        *---------------------------------------------------------------------------
        IF EMPTY( aLine )
          bo_write( oOutHandle, oBuffObj1[ newline ] )
          show_out( '' )
          lMoreToGo  := .F.
          cContSpace := ''
          lContSpace := .F.
          LOOP
        ENDIF

        *---------------------------------------------------------------------------
        * Kill Click Headers
        *---------------------------------------------------------------------------
        IF PAD( cOrigLine, 2 ) == '*'  // old style headers that sucked
          LOOP
        ENDIF

        IF lClickKill
          IF PAD( cOrigLine, 2 ) == '*+'
            LOOP
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * Kill Snap Headers
        *---------------------------------------------------------------------------
        IF lSnapKill
          IF PAD( cOrigLine, 2 ) $ '*:|*!'
            LOOP
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * Kill Multi-Edit headers
        *---------------------------------------------------------------------------
        IF lMultKill
          IF PAD( cOrigLine, 2 ) == '#/' .OR. ;
                 LEFT( cOrigLine, 6 ) == '/* --%'
            LOOP
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * Check for /* and */ comments and skip them
        *---------------------------------------------------------------------------
        IF lCommentMode
          IF ( nPointer := AT( '*/', cOrigLine ) ) > 0
            nPointer ++
            lCommentMode := .F.
            bo_write( oOutHandle, LEFT( cOrigLine, nPointer ) + oBuffObj1[ newline ] )
            show_out( LEFT( cOrigLine, nPointer ) )
            cOrigLIne := SUBSTR( cOrigLine, nPointer + 1 )
            IF .NOT. EMPTY( cOrigLine )
              nStripComment := nPointer + 1
            ENDIF
            LOOP
          ELSE
            bo_write( oOutHandle, cOrigLine + oBuffObj1[ newline ] )
            show_out( cOrigLine )
            LOOP
          ENDIF
        ELSE
          IF ATAIL( aType ) == '/*'
            lCommentMode := .T.
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * write comments and loop
        *---------------------------------------------------------------------------
        IF LEFT( aLine[ 1 ], 1 ) == '*' .AND. !llastcontinue  //no comments in middle of line 3/06
          cOrigLine := ALLTRIM( cOrigLine )
          nOrigLen  := LEN( cOrigLine )
          IF lConvertStar
            DO CASE
            CASE nOrigLen == 1
              cOrigLine := '//'
            CASE nOrigLen > 1 .AND. LEFT( cOrigLine, 2 ) <> '*+'
              cOrigLine := '// ' + SUBSTR( cOrigLine, 2 )
            ENDCASE
          ENDIF
          bo_write( oOutHandle, SPACE( IndentLevel() ) + cOrigline + oBuffObj1[ newline ] )
          show_out( SPACE( IndentLevel() ) + cOrigLine )
          lDumpBuffer := .T.
          LOOP
        ENDIF

        *---------------------------------------------------------------------------
        * write # directives and loop
        *---------------------------------------------------------------------------
        IF aType[ 1 ] == '#'

          bo_write( oOutHandle, LTRIM( cOrigLine ) + oBuffObj1[ newline ] )
          lDumpBuffer := .T.
          show_out( LTRIM( cOrigLine ) )
          IF ASCAN( aType, 'LC' ) > 0
            // if right( trim( cOrigLine ), 1 ) == ';'
            DO WHILE .T.
              cOrigLine := bReadLine( oBuffObj1 )
              @  6, 67 SAY STR( bLineNumber( oBuffObj1 ), 8 )
              bo_write( oOutHandle, cOrigLine + oBuffObj1[ newline ] )
              show_out( LTRIM( cOrigLine ) )
              aParse := lineparse( cOrigLine )
              aLine  := aParse[ 1 ]
              aType  := aParse[ 2 ]
              IF ASCAN( aType, 'LC' ) == 0
                EXIT
              ENDIF
            ENDDO
          ENDIF
          LOOP
        ENDIF

        *---------------------------------------------------------------------------
        * smart indent on @
        *---------------------------------------------------------------------------
        IF aLine[ 1 ] == '@' .AND. !lLastContinue
          IF LEN( aLine ) > 2
            IF VAL( aLine[ 3 ] ) < 10 .AND. aLine[ 3 ] $ '9876543210'
              aLine[ 3 ] := ' ' + aLine[ 3 ]
            ENDIF
          ENDIF
          IF LEN( aLine ) > 5
            IF VAL( aLine[ 6 ] ) < 10 .AND. aLine[ 6 ] $ '9876543210'
              aLine[ 6 ] := ' ' + aLine[ 6 ]
            ENDIF
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * clone the aLine array, but in upper case
        *---------------------------------------------------------------------------
        uLine    := ACLONE( aLine )
        nPointer := LEN( ULine )
        FOR y = 1 TO nPointer
          uLine[ y ] := UPPER( uLine[ y ] )
        NEXT y

        *---------------------------------------------------------------------------
        * it's possible that a line starts with a /**/ comment
        * if so, find the first non-comment pointer
        *---------------------------------------------------------------------------
        nFirstNonComment := 1
        FOR x := 1 TO nPointer
          IF aType[ x ] == '/**/' .OR. aLine[ x ] == ' '
            nFirstNonComment := x + 1
            IF nFirstNonComment > LEN( aType )
              nFirstNonComment := 1
            ENDIF
          ELSE
            EXIT
          ENDIF
        NEXT

        *---------------------------------------------------------------------------
        * decrease the indent level on an END or NEXT
        *---------------------------------------------------------------------------
        IF .NOT. lLastContinue
          BEGIN SEQUENCE
            //this will pickup both 'C' and 'CT' types
            IF aType[ nFirstNonComment ] $ 'CT' .AND. ;
                      ( LEFT( uLine[ nFirstNonComment ], 3 ) == 'END' .OR. ;
                      LEFT( uLine[ nFirstNonComment ], 4 ) == 'NEXT' )

              IF ( LEFT( uLine[ nFirstNonComment ], 8 ) == 'ENDCLASS' .OR. ;
                  ( LEN( uLine ) > 2 .AND. ;
                  LEFT( uLine[ nFirstNonComment ], 3 ) == 'END' ) .AND. ;
                  LEFT( uLine[ nFirstNonComment + 2 ], 5 ) == 'CLASS' )
                BREAK
              ENDIF

              cLast := pop_stack( aStack )
              DO CASE
              CASE EMPTY( cLast )
                cErrorText := 'Control Underflow: Error detected at line ' + ALLTRIM( STR( nLineCount ) )
                IF lErrNotify
                  pop_msg( cErrorText )
                ENDIF
                err_log( cClickLog, cPathFile )
                err_log( cClickLog, cErrorText )
                err_log( cClickLog, '' )
                IndentReset()
                aStack := {}
              CASE cLast == 'IF'
                nIndIf --
              CASE cLast == 'FOR'
                nIndFor --
              CASE cLast == 'CASE'
                nIndCase --
                IF lCaseIndent .AND. cLast == 'CASE'
                  nIndCase --
                ENDIF
              CASE cLast == 'BEGIN'
                nIndBegin --
              CASE cLast == 'WHILE'
                nIndWhile --
              ENDCASE

            ENDIF
          END SEQUENCE
        ENDIF

        IF lFuncIndent

          *---------------------------------------------------------------------------
          * read ahead to see if this is the last return
          *---------------------------------------------------------------------------
          IF aType[ nFirstNonComment ] $ 'CT' .AND. LEFT( uLine[ nFirstNonComment ], 4 ) == 'RETU'
            oBuffSave := bGetSet( oBuffObj1 )   //save pointer position

            lTempFunction := .F.
            lOnReturn     := .T.
            tType         := ACLONE( aType )
            DO WHILE .T.

              IF lOnReturn
                IF ASCAN( tType, 'LC' ) > 0
                  bTempLine := bReadPart( oBuffObj1 )
                  tLine     := bTempLine[ 1 ]
                  tType     := bTempLine[ 2 ]
                  LOOP
                ENDIF
                lOnReturn := .F.
              ENDIF

              bTempLine := bReadPart( oBuffObj1 )

              tLine := bTempLine[ 1 ]
              tType := bTempLine[ 2 ]

              DO CASE
              CASE LEN( tLine ) > 2 .AND. ;
                  UPPER( PAD( tLine[ 1 ], 4 ) ) $ 'FUNC|PROC|METH|CLAS' .AND. ;
                  tType[ 1 ] $ 'CT' .AND. ;
                  LEFT( tLine[ 2 ], 1 ) <> '('
                lTempFunction := .T.
              CASE LEN( tLine ) > 4 .AND. ;
                  UPPER( LEFT( tLine[ 1 ], 4 ) ) $ 'STAT|EXIT|INIT' .AND. ;
                  tType[ 3 ] $ 'CT' .AND. ;
                  UPPER( PAD( tLine[ 3 ], 4 ) ) $ 'FUNC|PROC|METH|CLAS'
                lTempFunction := .T.
              CASE bEof( oBuffObj1 )
                lTempFunction := .T.
              CASE EMPTY( tLine ) .OR. '//' $ tType[ 1 ] .OR. '/*' $ tType[ 1 ]
              OTHERWISE
                EXIT
              ENDCASE

              IF lTempFunction
                nIndFunc --
                EXIT
              ENDIF

            ENDDO

            oBuffObj1 := bRestSet( oBuffSave )  //restore pointer position to obuffsave
          ENDIF

        ENDIF

        *---------------------------------------------------------------------------
        * check for underflow at any time
        *---------------------------------------------------------------------------
        IF IndentLevel() < 0
          cErrorText := 'Control Underflow: Error detected at line ' + ALLTRIM( STR( nLineCount ) )
          IF lErrNotify
            pop_msg( cErrorText )
          ENDIF
          err_log( cClickLog, cPathFile )
          err_log( cClickLog, cErrorText )
          err_log( cClickLog, '' )
          IndentReset()
          aStack := {}
        ENDIF

        *---------------------------------------------------------------------------
        * correct Replace x with y statements if necessary
        *---------------------------------------------------------------------------
        IF lRepl2Assign .AND. lDeclBust
          IF aType[ nFirstNonComment ] $ 'CT' .AND. ;
                    LEFT( uLine[ nFirstNonComment ], 4 ) == 'REPL'

            IF ASCAN( uLine, 'ALL' ) == 0 .AND. ;
                     ASCAN( uLine, 'WHIL' ) == 0 .AND. ;
                     ASCAN( uLine, 'FOR' ) == 0 .AND. ;
                     ASCAN( uLine, 'REST' ) == 0 .AND. ;
                     ASCAN( uLine, 'RECO' ) == 0 .AND. ;
                     ASCAN( uLine, 'NEXT' ) == 0

              *---------------------------------------------------------------------------
              * Dump the word REPLACE and the space following it
              *---------------------------------------------------------------------------
              ADEL( aLine, 1 )
              ADEL( aLine, 1 )
              ASIZE( aLine, LEN( aLine ) - 2 )

              ADEL( uLine, 1 )
              ADEL( uLine, 1 )
              ASIZE( uLine, LEN( aLine ) )

              ADEL( aType, 1 )
              ADEL( aType, 1 )
              ASIZE( aType, LEN( aLine ) )

              *---------------------------------------------------------------------------
              * put the field-> designator on the field name if needed
              *---------------------------------------------------------------------------
              IF AT( '->', aLine[ 1 ] ) == 0
                aLine[ 1 ] := 'FIELD->' + aLine[ 1 ]
                uLine[ 1 ] := 'FIELD->' + uLine[ 1 ]
              ENDIF

              *---------------------------------------------------------------------------
              * Then, replace the WITH with an :=
              *---------------------------------------------------------------------------
              nPointer := LEN( aLine )
              FOR x = 1 TO nPointer
                IF uLine[ x ] == 'WITH'
                  aLine[ x ] := ':='
                  uLine[ x ] := ':='
                  aType[ x ] := 'O'
                ENDIF
              NEXT x

            ENDIF

          ENDIF
        ENDIF

        IF lMode5   //are we in clipper5.x mode?

          *---------------------------------------------------------------------------
          * correct STORE x to y, m, w statements if necessary
          *---------------------------------------------------------------------------
          IF lStor2Assign
            IF aType[ nFirstNonComment ] $ 'CT' .AND. LEFT( uLine[ nFirstNonComment ], 4 ) == 'STOR'

              DO CASE
              CASE ATAIL( aType ) == 'LC'
                cErrorText := 'No Conversion of STORE due to ; at end of line ' + ALLTRIM( STR( nLineCount ) )
                IF lErrNotify
                  pop_msg( cErrorText )
                ENDIF
                err_log( cClickLog, cPathFile )
                err_log( cClickLog, cErrorText )
                err_log( cClickLog, '' )

              OTHERWISE

                // Dump the word STORE and the space following it

                ADEL( aLine, 1 )
                ADEL( aLine, 1 )
                ASIZE( aLine, LEN( aLine ) - 2 )

                ADEL( uLine, 1 )
                ADEL( uLine, 1 )
                ASIZE( uLine, LEN( aLine ) )

                ADEL( aType, 1 )
                ADEL( aType, 1 )
                ASIZE( aType, LEN( aLine ) )

                *---------------------------------------------------------------------------
                * Find the pointer to the TO command.
                *---------------------------------------------------------------------------
                nTo := ASCAN( uLine, { | x | x == 'TO' } )

                IF nTo > 0

                  *---------------------------------------------------------------------------
                  * grab the left half (assignment)
                  *---------------------------------------------------------------------------
                  aNewLine := ACLONE( aLine )
                  aNewType := ACLONE( aType )

                  aAss := {}
                  aTss := {}
                  FOR x := 1 TO nTo - 2
                    AADD( aAss, aNewLine[ x ] )
                    AADD( aTss, aNewType[ x ] )
                  NEXT

                  *---------------------------------------------------------------------------
                  * grab the vars to assign to
                  *---------------------------------------------------------------------------
                  aVars       := {}
                  aTars       := {}
                  nParenCount := 0
                  FOR x := nTo + 2 TO LEN( aLine )
                    IF aType[ x ] == '+'
                      nParenCount ++
                    ENDIF
                    IF aType[ x ] == '-'
                      nParenCount --
                    ENDIF
                    IF aLine[ x ] == ',' .AND. nParenCount == 0
                      AADD( aVars, ' :=' )
                      AADD( aTars, 'O' )
                    ELSE
                      AADD( aVars, aNewLine[ x ] )
                      AADD( aTars, aNewType[ x ] )
                    ENDIF
                  NEXT

                  AADD( aVars, ' := ' )
                  AADD( aTars, 'O' )

                  aLine := ACLONE( aVars )
                  aType := ACLONE( aTars )

                  FOR x := 1 TO LEN( aAss )
                    AADD( aLine, aAss[ x ] )
                    AADD( aType, aTss[ x ] )
                  NEXT

                ENDIF
              ENDCASE
            ENDIF
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * does this line start a function or method?
        * remember you never list a function until it is called
        *---------------------------------------------------------------------------
        lGotFunction := .F.
        IF LEN( aLine ) > 2 .AND. ;
               UPPER( PAD( aLine[ 1 ], 4 ) ) $ 'FUNC|PROC|METH|CLAS' .AND. ;
               aType[ 1 ] $ 'CT' .AND. ;
               LEFT( aLine[ 2 ], 1 ) <> '('
          lGotFunction := .T.
        ENDIF
        IF LEN( aLine ) > 4 .AND. ;
               UPPER( LEFT( aLine[ 1 ], 4 ) ) $ 'STAT|EXIT|INIT|CREA' .AND. ;
               aType[ 3 ] $ 'CT' .AND. ;
               UPPER( PAD( aLine[ 3 ], 4 ) ) $ 'FUNC|PROC|METH|CLAS'
          lGotFunction := .T.
        ENDIF

        *---------------------------------------------------------------------------
        * turn off header detection in the middle of a class creation
        *---------------------------------------------------------------------------
        IF lGotFunction .AND. lGotClass
          lGotFunction := .F.
        ENDIF

        IF nIndFunc > 0 .AND. lFuncIndent .AND. lGotFunction
          nIndFunc --
        ENDIF

        *---------------------------------------------------------------------------
        * check for overflow and create header if necessary
        *---------------------------------------------------------------------------
        IF lGotFunction .AND. !EMPTY( cHeadText := func_head( aLine, oBuffObj1 ) )
          IF IndentLevel() > 0
            cErrorText := 'Control Overflow: Error detected at line ' + ALLTRIM( STR( nLineCount ) )
            IF lErrNotify
              pop_msg( cErrorText )
            ENDIF
            err_log( cClickLog, cPathFile )
            err_log( cClickLog, cErrorText )
            err_log( cClickLog, '' )
          ENDIF
          IndentReset()
          aStack := {}
          IF lClickFunc
            bo_write( oOutHandle, cHeadText )
          ENDIF
        ENDIF

        *---------------------------------------------------------------------------
        * this is the function that builds cross references
        * 03/06 added a 'P' in atype for do procedure references,
        * could have used the 'F'
        * remember only define procedures when they are called!!!
        *---------------------------------------------------------------------------
        IF .NOT. lGotFunction
          func_call( aLine, aType, cOrigLine )
        ENDIF

        *---------------------------------------------------------------------------
        * identify the function IF( by comma in program line
        * remember, anything followed is already assumed to be
        * a function, so if we find it's not a function, we 
        * make it a command and put back the missing space
        *---------------------------------------------------------------------------
        IF UPPER( aLine[ nFirstNonComment ] ) == 'IF' .AND. LEFT( aLine[ nFirstNonComment + 1 ], 1 ) == '('
          nPointer    := LEN( aLine )
          nParenCount := 0
          lIfCommand  := .T.
          lGotOne     := .F.  // .T. means we got a command

          IF nPointer >= nFirstNonComment + 4
            IF '=' $ aType[ nFirstNonComment + 4 ]
              lGotOne := .T.  //this means we got a command
            ENDIF
          ENDIF

          IF .NOT. lGotOne
            FOR x := nFirstNonComment TO nPointer
              IF aType[ x ] == '+' .OR. ( aType[ x ] == 'V' .AND. '(' $ aLine[ x ] )
                nParenCount ++
                lGotOne := .T.
              ENDIF
              IF aType[ x ] == '-' .OR. ( aType[ x ] == 'V' .AND. ')' $ aLine[ x ] )
                nParenCount --
              ENDIF
              IF aLIne[ x ] == ',' .AND. nParenCount == 1
                lIfCommand := .F.
                EXIT
              ENDIF
              IF nParenCount == 0 .AND. lGotOne
                EXIT
              ENDIF
            NEXT
          ENDIF

          IF lIfCommand
            aType[ nFirstNonComment ] := 'CT'
            ASIZE( aLine, LEN( aLine ) + 1 )
            ASIZE( aType, LEN( aType ) + 1 )
            AINS( aLine, nFirstNonComment + 1 )
            AINS( aType, nFirstNonComment + 1 )
            aLine[ nFirstNonComment + 1 ] := ' '
            aType[ nFirstNonComment + 1 ] := 'SP'
          ENDIF

        ENDIF

        IF lGotFunction .AND. LEN( aLine ) > 2 .AND. ;
                  ( ( UPPER( LEFT( aLine[ 1 ], 5 ) ) == 'CLASS' .AND. ;
                  UPPER( LEFT( aLine[ 3 ], 6 ) ) <> 'METHOD' ) .OR. ;
                  ( UPPER( LEFT( aLine[ 1 ], 6 ) ) == 'CREATE' .AND. ;
                  UPPER( LEFT( aLine[ 3 ], 5 ) ) == 'CLASS' ) )
          lGotClass := .T.
        ENDIF

        IF lGotClass .AND. ;
                  ( UPPER( LEFT( aLine[ 1 ], 8 ) ) == 'ENDCLASS' .OR. ;
                  ( LEN( aLine ) > 2 .AND. ;
                  UPPER( LEFT( aLine[ 1 ], 3 ) ) == 'END' .AND. ;
                  UPPER( LEFT( aLine[ 3 ], 5 ) ) == 'CLASS' ) )
          lGotClass := .F.
        ENDIF

        cThisLine := ''
        cComment  := ''
        nLineLen  := LEN( aLine )
        FOR y := 1 TO nLineLen
          IF aType[ y ] == '//' .AND. y > 1
            cComment := aLine[ y ]
          ELSE
            cThisLine += aLine[ y ]
          ENDIF
        NEXT

        uThisLine := UPPER( cThisLine )

        nUnFor      := 0
        nUnCase     := 0
        nUnSequence := 0

        IF aType[ nFirstNonComment ] $ 'CT'
          cFirstWord := UPPER( PAD( aLine[ nFirstNonComment ], 4 ) )
          DO CASE
          CASE cFirstWord == 'ELSE'
            nUnFor := 1
          CASE cFirstWord $ 'CASE|OTHE'
            nUnCase := 1
          CASE cFirstWord == 'RECO'
            nUnSequence := 1
          ENDCASE
        ENDIF

        cOutput := SPACE( IndentLevel() ) + cContSpace + cThisLine

        nUnFor      := 0
        nUnCase     := 0
        nUnSequence := 0

        IF .NOT. EMPTY( cComment )
          nOutPad  := LEN( cOutput )
          nOutPad  += nComntTab - ( nOutPad % nComntTab )
          cOutput  := PAD( cOutput, nOutPad ) + cComment
          cComment := ''
        ENDIF

        //most lines get written out here
        IF lFuncIndent .AND. !lLocIndent
          cTemp := UPPER( LTRIM( cOutput ) )
          IF PAD( UPPER( ALLTRIM( cTemp ) ), 4 ) $ ;
                 'LOCA|PRIV|MEMV|STAT|PUBL|FIEL'
            cOutput := LTRIM( cOutput )
          ENDIF
          bo_write( oOutHandle, cOutput + oBuffObj1[ newline ] )
          show_out( cOutput )
        ELSE
          bo_write( oOutHandle, cOutput + oBuffObj1[ newline ] )
          show_out( cOutput )
        ENDIF

        IF lGotFunction .AND. !lRemDupMTLine .AND. !ASCAN( aType, 'LC' ) > 0
          bo_write( oOutHandle, oBuffObj1[ newline ] )
        ENDIF

        IF .NOT. lLastContinue
          cThisText := UPPER( aLine[ nFirstNonComment ] )
          DO CASE
          CASE cThisText == 'IF'
            DO CASE
            CASE LEFT( aLine[ nFirstNonComment + 1 ], 1 ) <> '('
              nIndIf ++
              AADD( aStack, 'IF' )
            CASE aType[ nFirstNonComment ] $ 'CT'
              nIndIf ++
              AADD( aStack, 'IF' )
            ENDCASE

          CASE lFuncIndent .AND. lGotFunction
            nIndFunc ++
            AADD( aStack, 'FUNC' )

          OTHERWISE
            // do not indent these if they are variables
            IF aType[ nFirstNonComment ] $ 'CT'
              DO CASE
              CASE LEFT( cThisText, 7 ) == 'DO WHIL'
                nIndWhile ++
                AADD( aStack, 'WHILE' )
              CASE LEFT( cThisText, 4 ) == 'WHIL'
                nIndWhile ++
                AADD( aStack, 'WHILE' )
              CASE PAD( cThisText, 4 ) == 'FOR '
                nIndFor ++
                AADD( aStack, 'FOR' )
              CASE LEFT( cThisText, 7 ) == 'DO CASE'
                nIndCase ++
                AADD( aStack, 'CASE' )
                IF lCaseIndent
                  nIndCase ++
                ENDIF
              CASE LEFT( cThisText, 4 ) == 'BEGI'
                nIndBegin ++
                AADD( aStack, 'BEGIN' )
              ENDCASE
            ENDIF
          ENDCASE

        ENDIF

        *---------------------------------------------------------------------------
        * The smart alignment section of Click!
        *---------------------------------------------------------------------------
        IF ASCAN( aType, 'LC' ) > 0
          IF .NOT. lContSpace
            cContSpace := ''
            nLineLen   := LEN( aLine )
            DO CASE
            CASE UPPER( aLine[ nFirstNonComment ] ) == 'IF'
              DO CASE
              CASE nLineLen > 6 .AND. aLine[ 7 ] == '{'
                cContSpace := SPACE( LEN( afront( aLine, 8 ) ) - 3 )
              CASE nLineLen > 5 .AND. aLine[ 6 ] == '{'
                cContSpace := SPACE( LEN( afront( aLine, 7 ) ) - 3 )
              CASE nLineLen > 4 .AND. aLine[ 5 ] == '('
                IF nLineLen > 9 .AND. aLine[ 9 ] == ':='
                  cContSpace := SPACE( LEN( afront( aLine, 10 ) ) - 3 )
                ELSE
                  cContSpace := SPACE( LEN( afront( aLine, 6 ) ) - 3 )
                ENDIF
              CASE nLineLen > 3 .AND. aLine[ 4 ] == '('
                IF nLineLen > 8 .AND. aLine[ 8 ] == ':='
                  cContSpace := SPACE( LEN( afront( aLine, 9 ) ) - 3 )
                ELSE
                  cContSpace := SPACE( LEN( afront( aLine, 5 ) ) - 3 )
                ENDIF
              CASE nLineLen > 2 .AND. aLine[ 3 ] == '('
                IF nLineLen > 7 .AND. aLine[ 7 ] == ':='
                  cContSpace := SPACE( LEN( afront( aLine, 8 ) ) - 3 )
                ELSE
                  cContSpace := SPACE( LEN( afront( aLine, 4 ) ) - 3 )
                ENDIF
              CASE nLineLen > 3 .AND. aLine[ 4 ] == '->' .AND. aLine[ nFirstNonComment + 4 ] == '('
                cContSpace := SPACE( LEN( afront( aLine, nFirstNonComment + 5 ) ) - 3 )
              CASE nLineLen > 1 .AND. aLine[ 2 ] == '(' .AND. aType[ nFirstNonComment ] $ 'CT'
                cContSpace := SPACE( LEN( afront( aLine, nFirstNonComment + 3 ) ) )
              CASE aLine[ 2 ] == '('
                cContSpace := SPACE( LEN( afront( aLine, 3 ) ) )
              OTHERWISE
                cContSpace := SPACE( nDefIndent )
              ENDCASE
            CASE UPPER( aLine[ 1 ] ) == 'DO'
              cContSpace := SPACE( LEN( afront( aLine, 4 ) ) - 3 )
            CASE UPPER( LEFT( aLine[ 1 ], 4 ) ) == 'WHIL'
              cContSpace := SPACE( LEN( afront( aLine, 2 ) ) - 3 )
            OTHERWISE
              DO CASE
                //3/06 smart aligner not always correctly spacing line continue
              CASE llastContinue  //3/06 continue with spacing
                //no more indent for second/third continue lines
              CASE llineContinue  //3/06 a continue line, indent from previous line
                cContSpace := cContSpace + SPACE( nTabContinue )
              CASE nLineLen > 6 .AND. aLine[ 3 ] == ':=' .AND. aLine[ 7 ] == '+'
                cContSpace := SPACE( LEN( afront( aLine, 4 ) ) )
              CASE ( nPointer := ASCAN( aLine, '{' ) ) > 0
                IF nPointer < nMaxSmartAlign
                  cContSpace := SPACE( LEN( afront( aLine, nPointer + 1 ) ) )
                ENDIF
              CASE ( nPointer := ASCAN( aLine, '(' ) ) > 0  //left paren
                IF nPointer < nMaxSmartAlign
                  cContSpace := SPACE( LEN( afront( aLine, nPointer + 1 ) ) )
                ENDIF
              ENDCASE
            ENDCASE
            IF LEN( cContSpace ) == 0 .AND. !llineContinue  //3/06 stop no additional
              cContSpace := SPACE( nDefIndent )   //indent on lLineContinue
            ENDIF   //going to nDefIndent
            lContSpace := .T.
          ENDIF   //!lContSpace
        ELSE
          cContSpace := ''
          lContSpace := .F.
        ENDIF

      ENDDO   //done with file (BIG LOOP)  start at ~606

      IF lClickEOF

        IF .NOT. lRemDupMTLine
          bo_write( oOutHandle, oBuffObj1[ newline ] )
        ENDIF
        bo_write( oOutHandle, '*+ EOF: ' + cThisFile + oBuffObj1[ newline ] )
        show_out( '*+ EOF: ' + cThisFile )

      ENDIF

      bo_close( oOutHandle )

      bclose( oBuffObj1 )

      IF lFuncIndent .AND. nIndFunc == 1
        nIndFunc --
      ENDIF

      IF IndentLevel() < 0
        cErrorText := 'Control Underflow: Error detected at line ' + ALLTRIM( STR( nLineCount ) )
        IF lErrNotify
          pop_msg( cErrorText )
        ENDIF
        err_log( cClickLog, cPathFile )
        err_log( cClickLog, cErrorText )
        err_log( cClickLog, '' )
      ENDIF

      IF IndentLevel() > 0
        cErrorText := 'Control Overflow: Error detected at line ' + ALLTRIM( STR( nLineCount ) )
        IF lErrNotify
          pop_msg( cErrorText )
        ENDIF
        err_log( cClickLog, cPathFile )
        err_log( cClickLog, cErrorText )
        err_log( cClickLog, '' )
      ENDIF

      end_func_text()

      IF lTheAligner
        @  6, 10 SAY ;
          TheAligner( '$prealin.tmp', cOutDir + dirsep + RootName( cThisFile ) + cOutExt, cClickini )
      ENDIF

      //  03/06 commented out option to set write time of output file
      //         if lRetTimeDate
      //            setfdati( cOutDir + '\' + RootName( cThisFile ) + cOutExt, filedate( cThisFile ), filetime( cThisFile ) )
      //         endif

    ENDIF

    IF LASTKEY() == 27
      EXIT
    ENDIF

  NEXT  //for xx:=1 to nNumFiles ~line 400 once for each file

  func_text( aLibList, aFileList, cClickini )

END SEQUENCE

IF lDeclBust
  FERASE( '$declbst.tmp' )
ENDIF

IF lTheAligner
  FERASE( '$prealin.tmp' )
ENDIF

lVerbose := .T.

SCROLL( 9, 1, nMidScreen - 1, MAXCOL() - 1 )
SCROLL( nMidScreen + 1, 1, MAXROW() - 3, MAXCOL() - 1 )

show_out( 'Processed ' + ALLTRIM( STR( nFileCount ) ) + ' files, containing ' + ALLTRIM( STR( nMasterCount ) ) + ' lines of source code' )
show_out( '' )
show_out( 'Time in process: ' + diff2jul( td2jul(), nStartJulian ) )
show_out( '' )

err_log( cClickLog, '>>>>>> Click! Run End:   ' + DTOS( DATE() ) + ' ' + TIME() )
err_log( cClickLog, '' )

IF LASTKEY() == 27
  ERRORLEVEL( 1 )
ENDIF

exitproc()
RETURN  //Procedure click


****************************************************************************
STATIC FUNCTION afront( aLine, nHowMany )
****************************************************************************
LOCAL cSomeData := ''
LOCAL x

nHowMany := MIN( nHowMany, LEN( aLine ) )

IF nHowMany > 0
  FOR x := 1 TO nHowMany
    cSomeData += aLine[ x ]
  NEXT
ENDIF

RETURN cSomeData


****************************************************************************
STATIC FUNCTION bReadPart( oBuffObj1 )
****************************************************************************
LOCAL aLineParts := {}
LOCAL aLeftLine  := {}
LOCAL aLeftType  := {}

LOCAL cComment
LOCAL cThisLine

LOCAL nNumParts
LOCAL nNumDivs
LOCAL x
LOCAL nLBPointer
LOCAL nNumTaken
LOCAL lClickIgnore := .F.
LOCAL nOldPcntDone
LOCAL nPcntDone    := 0

STATIC aLine     := {}
STATIC aType     := {}
STATIC cLineBuff := ''

IF lDumpBuffer
  aLine       := {}
  aType       := {}
  cLineBuff   := ''
  lDumpBuffer := .F.
ENDIF

IF EMPTY( aLine )

  DO WHILE .T.

    IF nStripComment > 0
      cLineBuff     := SUBSTR( cLineBuff, nStripComment )
      nStripComment := 0
    ELSE
      cLineBuff := bReadLine( oBuffObj1 )
      @  6, 67 SAY STR( bLineNumber( oBuffObj1 ), 8 )
      show_in( cLineBuff )
      nLineCount ++
      nMasterCount ++

      nOldPcntDone := nPcntDone
      nPcntDone    := INT( bRelative( oBuffObj1 ) * 50 )
      IF nOldPcntDone <> nPcntDone
        @  6, 14 SAY REPLICATE( '', nPcntDone ) COLOR 'GB+/B'
      ENDIF

      IF UPPER( TabSpStrip( cLineBuff ) ) == '*+CLICKOFF' .OR. ;
               UPPER( TabSpStrip( cLineBuff ) ) == 'TEXT'
        lClickIgnore := .T.
      ENDIF
      IF lClickIgnore
        bo_write( oOutHandle, cLineBuff + oBuffObj1[ newline ] )
        show_out( cLineBuff )
        IF UPPER( TabSpStrip( cLineBuff ) ) == '*+CLICKON' .OR. ;
                 UPPER( TabSpStrip( cLineBuff ) ) == 'ENDTEXT' .OR. ;
                 bEof( oBuffObj1 )
          lClickIgnore := .F.
        ENDIF
        LOOP
      ENDIF
    ENDIF

    cLineBuff := tabstrip( cLineBuff )

    IF lCommentMode .AND. !( '*/' $ cLineBuff ) .AND. !bEof( oBuffObj1 )
      bo_write( oOutHandle, cLineBuff + oBuffObj1[ newline ] )
      show_out( cLineBuff )
      LOOP
    ELSE
      EXIT
    ENDIF

  ENDDO

  cThisLine := ALLTRIM( cLineBuff )

  // waste any remaining tabs or spaces on the left of the line
  cThisLine := TabSpStrip( cThisLine )

  IF LEFT( cThisLine, 1 ) == '*'
    aLine := { cThisLine }
    aType := { '  //' }
  ELSE
    aLineParts := lineparse( cThisLine )
    aLine      := aLineParts[ 1 ]
    aType      := alineParts[ 2 ]
  ENDIF

ENDIF

// Is this a multipart command with a comment?
// If so, comment goes in second position

// if this is the beginning of a strikeout section, comment stays on end

nNumParts  := LEN( aLine )
nNumDivs   := 0
nLBPointer := 0
FOR x := 1 TO nNumParts
  IF aType[ x ] == 'LB'
    IF EMPTY( nLBPointer )
      // this grabs an array pointer to the last item before the LB
      nLBPointer := x - 1
    ENDIF
    nNumDivs ++
  ENDIF
NEXT

IF nNumDivs > 0

  cComment := ''
  IF ATAIL( aType ) == '//'
    // remove the comment to be appended to first element
    cComment := aLine[ LEN( aLine ) ]
    ASIZE( aLine, LEN( aLine ) - 2 )
    ASIZE( aType, LEN( aType ) - 2 )
  ENDIF

  aLeftLine := {}
  aLeftType := {}
  FOR x := 1 TO nLBPointer
    AADD( aLeftLine, aLine[ x ] )
    AADD( aLeftType, aType[ x ] )
  NEXT

  nNumTaken := LEN( aLeftLine ) + 2   // toss the data, LB and space
  FOR x := 1 TO nNumTaken
    ADEL( aLine, 1 )
    ADEL( aType, 1 )
  NEXT
  ASIZE( aLine, LEN( aLine ) - nNumTaken )
  ASIZE( aType, LEN( aType ) - nNumTaken )

  // if we grabbed a comment off of the end of the line,
  // we append it to the first line element

  IF .NOT. EMPTY( cComment )
    AADD( aLeftLine, ' ' )
    AADD( aLeftType, 'SP' )
    AADD( aLeftLine, cComment )
    AADD( aLeftType, '//' )
  ENDIF

  lMoreToGo := .T.

ELSE
  aLeftLine := aLine
  aLeftType := aType
  aLine     := {}
  aType     := {}
  lMoreToGo := .F.
ENDIF
RETURN { aLeftLine, aLeftType, cLineBuff }  //function bReadPart


****************************************************************************
PROCEDURE centertext( cSomeText, nLineNumber, cColor )
****************************************************************************
@ nLineNumber, ( MAXCOL() - LEN( cSomeText ) ) / 2 SAY cSomeText COLOR cColor
RETURN



****************************************************************************
INIT PROCEDURE CLIPINIT
****************************************************************************
ERRORBLOCK( { | e | FWRITE( 2, CHR( 13 ) + CHR( 10 ) + 'ERROR ' + ;
  e:subsystem + ':' + LTRIM( STR( e:subcode ) ) ), __Quit() } )
RETURN


****************************************************************************
STATIC FUNCTION dbc_identify( aType )
****************************************************************************
LOCAL logic := .T.

IF LEN( aType ) >= 20

  DO CASE
  CASE aType[ 1 ] <> 'V'
    logic := .F.
  CASE aType[ 3 ] <> 'O'
    logic := .F.
  CASE aType[ 5 ] <> '+'
    logic := .F.
  CASE aType[ 7 ] <> '+'
    logic := .F.
  CASE aType[ 9 ] <> 'S'
    logic := .F.
  CASE aType[ 12 ] <> 'S'
    logic := .F.
  CASE aType[ 15 ] <> 'V'
    logic := .F.
  CASE aType[ 18 ] <> 'V'
    logic := .F.
  CASE aType[ 20 ] <> '-'
    logic := .F.
  ENDCASE
ELSE
  logic := .F.
ENDIF

RETURN logic

/*
****************************************************************************
PROCEDURE ERRORSYS()
****************************************************************************
RETURN
*/

****************************************************************************
STATIC PROCEDURE exitproc()
****************************************************************************
IF lRestScrn
  show_out( '  Press any Key to End Click!  ', 'GR+/R' )
  show_out( '' )
  INKEY( 0 )
  getscreen()
ELSE
  DEVPOS( MAXROW() - 2, 0 )
ENDIF

RETURN



****************************************************************************
STATIC FUNCTION func_head( aLine, oBuffObj1 )
****************************************************************************
LOCAL cDataOut := ''

LOCAL nWordLen
LOCAL cThisWord
LOCAL cFuncChars := ''

LOCAL lFunc := .F.
LOCAL lProc := .F.
LOCAL lClas := .F.
LOCAL lMeth := .F.

LOCAL lStat := .F.
LOCAL lInit := .F.
LOCAL lExit := .F.

IF LEN( aLine ) > 2
  cThisWord := UPPER( aLine[ 1 ] )
  IF LEN( cThisWord ) < 4
    cThisWord := PAD( cThisWord, 4 )
  ENDIF
  nWordLen := LEN( cThisWord )

  IF LEFT( 'FUNCTION', nWordLen ) == cThisWord
    lFunc := .T.
  ELSEIF LEFT( 'PROCEDURE', nWordLen ) == cThisWord
    lProc := .T.
  ELSEIF LEFT( 'METHOD', nWordLen ) == cThisWord .AND. ':' $ aLine[ 3 ]
    lMeth := .T.
  ELSEIF LEFT( 'CLASS', nWordLen ) == cThisWord
    lClas := .T.
  ELSEIF LEFT( 'CREATE', nWordLen ) == cThisWord
    lClas := .T.
  ENDIF

ENDIF

IF ( !lFunc .OR. !lProc .OR. !lMeth ) .AND. LEN( aLine ) > 4
  cThisWord := UPPER( aLine[ 1 ] )
  IF LEN( cThisWord ) < 4
    cThisWord := PAD( cThisWord, 4 )
  ENDIF
  nWordLen := LEN( cThisWord )

  IF LEFT( 'STATIC', nWordLen ) == cThisWord
    lStat := .T.
  ENDIF

  IF LEFT( 'INIT', nWordLen ) == cThisWord
    lInit := .T.
  ENDIF

  IF LEFT( 'EXIT', nWordLen ) == cThisWord
    lExit := .T.
  ENDIF

  IF lStat .OR. lInit .OR. lExit

    cThisWord := UPPER( aLine[ 3 ] )
    IF LEN( cThisWord ) < 4
      cThisWord := PAD( cThisWord, 4 )
    ENDIF
    nWordLen := LEN( cThisWord )

    IF LEFT( 'FUNCTION', nWordLen ) == cThisWord
      lFunc := .T.
    ELSEIF LEFT( 'PROCEDURE', nWordLen ) == cThisWord
      lProc := .T.
    ELSEIF LEFT( 'METHOD', nWordLen ) == cThisWord .AND. ':' $ aLine[ 3 ]
      lMeth := .T.
    ELSEIF LEFT( 'CLASS', nWordLen ) == cThisWord
      lClas := .T.
    ELSE
      lStat := .F.
    ENDIF

  ENDIF

ENDIF

IF lStat .OR. lInit .OR. lExit .OR. lFunc .OR. lProc .OR. lMeth .OR. lClas
  IF .NOT. lRemDupMTLine
    cDataOut += oBuffObj1[ newline ]
  ENDIF
  cDataOut += '*+' + REPLICATE( cFuncDiv, 68 ) + oBuffObj1[ newline ]
  show_out( '*+' + REPLICATE( cFuncDiv, 68 ) )
  cDataOut += '*+' + oBuffObj1[ newline ]
  show_out( '*+' )

  DO CASE
  CASE lStat .AND. lFunc
    cFuncChars := '*+' + SPACE( 4 ) + 'STATIC Function ' + aLine[ 5 ] + '()'
  CASE lStat .AND. lProc
    cFuncChars := '*+' + SPACE( 4 ) + 'STATIC Procedure ' + aLine[ 5 ] + '()'
  CASE lStat .AND. lMeth
    cFuncChars := '*+' + SPACE( 4 ) + 'STATIC Method ' + aLine[ 5 ] + '()'
  CASE lInit .AND. lFunc
    cFuncChars := '*+' + SPACE( 4 ) + 'Init Function ' + aLine[ 5 ] + '()'
  CASE lInit .AND. lProc
    cFuncChars := '*+' + SPACE( 4 ) + 'Init Procedure ' + aLine[ 5 ] + '()'
  CASE lInit .AND. lMeth
    cFuncChars := '*+' + SPACE( 4 ) + 'Init Method ' + aLine[ 5 ] + '()'
  CASE lExit .AND. lFunc
    cFuncChars := '*+' + SPACE( 4 ) + 'Exit Function ' + aLine[ 5 ] + '()'
  CASE lExit .AND. lProc
    cFuncChars := '*+' + SPACE( 4 ) + 'Exit Procedure ' + aLine[ 5 ] + '()'
  CASE lExit .AND. lMeth
    cFuncChars := '*+' + SPACE( 4 ) + 'Exit Method ' + aLine[ 5 ] + '()'
  CASE lFunc
    cFuncChars := '*+' + SPACE( 4 ) + 'Function ' + aLine[ 3 ] + '()'
  CASE lProc
    cFuncChars := '*+' + SPACE( 4 ) + 'Procedure ' + aLine[ 3 ] + '()'
  CASE lMeth
    cFuncChars := '*+' + SPACE( 4 ) + 'Method ' + aLine[ 3 ] + '()'
  CASE lClas .AND. UPPER( aLine[ 3 ] ) == 'METHOD'
    cFuncChars := '*+' + SPACE( 4 ) + 'Class Method ' + aLine[ 5 ] + '()'
  CASE lClas .AND. UPPER( aLine[ 1 ] ) == 'CREATE' .AND. UPPER( aLine[ 3 ] ) == 'CLASS'
    cFuncChars := '*+' + SPACE( 4 ) + 'Create Class ' + aLine[ 5 ] + '()'
  CASE lClas
    cFuncChars := '*+' + SPACE( 4 ) + 'Class ' + aLine[ 3 ]
  ENDCASE

  cDataOut += cFuncChars + oBuffObj1[ newline ]
  show_out( cFuncChars )

  functrak( SUBSTR( cFuncChars, 7 ) )

  cDataOut += '*+' + oBuffObj1[ newline ]
  show_out( '*+' )
  cDataOut += '*+' + REPLICATE( cFuncDiv, 68 ) + oBuffObj1[ newline ]
  show_out( '*+' + REPLICATE( cFuncDiv, 68 ) )
  cDataOut += '*+' + oBuffObj1[ newline ]
  show_out( '*+' )

ENDIF

RETURN cDataOut


****************************************************************************
STATIC FUNCTION IndentLevel()
****************************************************************************
RETURN ;
  ( nTabIf * nIndIf ) + ;
  ( nTabFor * ( nIndFor - nUnFor ) ) + ;
  ( nTabCase * ( nIndCase - nUnCase ) ) + ;
  ( nTabFunc * nIndFunc ) + ;
  ( nTabBegin * ( nIndBegin - nUnSequence ) ) + ;
  ( nTabWhile * nIndWhile )


****************************************************************************
STATIC PROCEDURE IndentReset()
****************************************************************************
nIndIf      := 0
nIndFor     := 0
nIndCase    := 0
nIndFunc    := 0
nIndBegin   := 0
nIndWhile   := 0
nUnFor      := 0
nUnCase     := 0
nUnSequence := 0
RETURN



****************************************************************************
STATIC FUNCTION leadspace( aString )
****************************************************************************
LOCAL x
LOCAL nStrLength := LEN( aString )

FOR x := 1 TO nStrLength
  IF SUBSTR( aString, x, 1 ) <> ' '
    x --
    EXIT
  ENDIF
NEXT

IF x > nStrLength
  x := nStrLength
ENDIF
RETURN x





****************************************************************************
FUNCTION lineparse( cThisLine )
// take a line of code and break it down into parts, return an array with
// parts (aline) and type of entry (atype) separated by 'SP' type entries
// FF=function  LB=line continuation (;)  LC=line continuation (;)
// //=comment  CT=comment (*)  /* and  */=more comment type
// C=in cmd_list()  M=macro N=number  0=various operator and separator pairs
// OP=matches click.ini cop_list   SP=space U=??  V=assign value(=)
// W=word which can update to C if in cmd_list becomes CT if not considered a function
// or FF if in click.ini function list,
// otherwise it ends up a V  F=functions  P=procedures for sorting
// U=?? but gets updated to LB,+,-,or OP if op_list
****************************************************************************
LOCAL lQuoteMode  := .F.
LOCAL lWordMode   := .F.
LOCAL lAction     := .F.
LOCAL lBrackMode  := .F.
LOCAL aLine       := {}
LOCAL aTemp1      := {}
LOCAL aTemp2      := {}
LOCAL aType       := {}
LOCAL cThisChar
LOCAL uThisChar
LOCAL cThisPair
LOCAL cWord
LOCAL cQuoteChar
LOCAL cLookFor
LOCAL cTheString  := ''
LOCAL cThisWord   := ''
LOCAL wordchars
LOCAL cRestOfline := ''
LOCAL nElements
LOCAL nPointer    := 0
LOCAL nLineLen    := LEN( cThisLine )
LOCAL x
LOCAL xx
LOCAL nX
LOCAL cLeft
LOCAL cRight
LOCAL uThisLine   := UPPER( cThisLine )
LOCAL lShortCut
LOCAL nParenLevel
LOCAL nStartElem

STATIC cTab := CHR( K_TAB )

BEGIN SEQUENCE

  IF LEFT( cThisLine, 1 ) == '*' .OR. lCommentMode
    aLine := { cThisLine }
    aType := { '  //' }
    BREAK
  ENDIF

  IF LEFT( cThisLine, 2 ) $ '//|&&'
    aLine := { cThisLine }
    aType := { '  //' }
    BREAK
  ENDIF

  IF LEFT( cThisLine, 1 ) == '#'
    aLine := { cThisLine }
    aType := { '#' }
    BREAK
  ENDIF

  lShortCut := .F.
  DO CASE
  CASE LEFT( uThisLIne, 4 ) == 'USE '
    lShortCut := .T.
  CASE LEFT( uThisLIne, 5 ) $ 'COPY |SAVE '
    lShortCut := .T.
  CASE LEFT( uThisLIne, 6 ) == 'ERASE '
    lShortCut := .T.
  CASE LEFT( uThisLIne, 7 ) == 'CREATE '
    lShortCut := .T.
  CASE LEFT( uThisLine, 8 ) $ 'COPY TO |' + ;
                              'RESTORE |' + ;
                              'SET COLO|' + ;
                              'SET ORDE'
    lShortCut := .T.
  CASE LEFT( uThisLine, 10 ) == 'COPY FILE '
    lShortCut := .T.
  CASE LEFT( uThisLine, 11 ) == 'DELETE FILE'
    lShortCut := .T.
  ENDCASE

  IF lShortCut
    nX := numtoken( cThisLine, ' ' )
    FOR x = 1 TO nX
      AADD( aLine, token( cThisLine, ' ', x ) )
      AADD( aType, 'V' )
      IF x < nX
        AADD( aLine, ' ' )
        AADD( aType, 'V' )
      ENDIF
    NEXT x

    nX := LEN( aLine )

    FOR x = 1 TO nX
      DO CASE
      CASE cmd_list( aLine[ x ], @nPointer )
        aType[ x ] := 'C'   //doesn't have * as first character
        IF aCmdLogic[ nPointer ]  //has an * as first character
          aType[ x ] := 'CT'
        ENDIF
        DO CASE
        CASE cComCase == 'UPPER'
          aLine[ x ] := UPPER( aLine[ x ] )
        CASE cComCase == 'LOWER'
          aLine[ x ] := LOWER( aLine[ x ] )
        CASE cComCase == 'PROPER'
          aLine[ x ] := proper( aLine[ x ] )
        CASE cComCase == 'LIKEINFILE'
          aLine[ x ] := TRIM( aCommand[ nPointer ] )
        ENDCASE
      CASE fnc_list( aLine[ x ], @nPointer )
        aType[ x ] := 'FF'
        // fix 13Dec'98 (DJW): case below was using cComCase instead of cFunCase
        DO CASE
        CASE cFunCase == 'UPPER'
          aLine[ x ] := UPPER( aLine[ x ] )
        CASE cFunCase == 'LOWER'
          aLine[ x ] := LOWER( aLine[ x ] )
        CASE cFunCase == 'PROPER'
          aLine[ x ] := proper( aLine[ x ] )
        CASE cFunCase == 'LIKEINFILE'
          aLine[ x ] := TRIM( aFunction[ nPointer ] )
        ENDCASE
      CASE aLine[ x ] == ';'
        aType[ x ] := 'LC'
      OTHERWISE
        aType[ x ] := 'V'
      ENDCASE
    NEXT x
    BREAK
  ENDIF

  FOR x = 1 TO nLineLen
    cThisChar := SUBSTR( cThisLine, x, 1 )
    uThisChar := UPPER( cThisChar )
    // padding added to eliminate recognition of single :
    cThisPair := PAD( SUBSTR( cThisLine, x, 2 ), 2 )

    IF cThisPair $ '&&|:='
      wordchars := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890._\'
    ELSE
      wordchars := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890._\&:'
    ENDIF

    // This is the beginning of a quote
    IF .NOT. lQuoteMode .AND. ( cThisChar == '"' .OR. cThisChar == "'" .OR. ( lBrackMode .AND. cThisChar == '[' ) )
      // If we are in word mode and find the start of a quote
      // save the word and end word mode, then start quote mode.
      IF lWordMode
        AADD( aLine, cThisWord )
        AADD( aType, 'W' )
        lWordMode := .F.
        cThisWord := ''
      ENDIF
      IF ( lBrackMode .AND. cThisChar == '[' )
        cQuoteChar := ']'
        cTheString := '['
      ELSE
        cQuoteChar := cThisChar
        cTheString := cThisChar
      ENDIF
      lQuoteMode := .T.
      LOOP
    ENDIF

    // This is the end of a quote
    IF lQuoteMode .AND. cThisChar == cQuoteChar
      cTheString += cThisChar
      AADD( aLine, cTheString )
      AADD( aType, 'S' )  // String
      cTheString := ''
      lQuoteMode := .F.
      LOOP
    ENDIF

    // if we are in quote mode, just gather the characters
    IF lQuoteMode
      cTheString += cThisChar
      LOOP
    ENDIF

    // this is the beginning of a word
    IF .NOT. lWordMode .AND. uThisChar $ wordchars
      lWordMode := .T.
      IF x == nLineLen
        AADD( aLine, cThisChar )
        AADD( aType, 'W' )  // Word
      ELSE
        cThisWord := cThisChar
      ENDIF
      lBrackMode := .F.
      LOOP
    ENDIF

    // This is the end of a word
    IF lWordMode .AND. ( !( uThisChar $ wordchars ) .OR. x == nLineLen )
      IF x == nLineLen .AND. uThisChar $ wordchars
        AADD( aLine, cThisWord + cThisChar )
        AADD( aType, 'W' )
        EXIT
      ELSE
        AADD( aLine, cThisWord )
        AADD( aType, 'W' )
      ENDIF
      lWordMode := .F.
      cThisWord := ''
    ENDIF

    // if we are in word mode, just gather the characters
    IF lWordMode
      cThisWord += cThisChar
      LOOP
    ENDIF

    DO CASE
    CASE cThisPair == '/*'
      cRestOfLine := SUBSTR( cThisLine, x )
      IF ( npointer := AT( '*/', cRestOfLine ) ) > 0
        AADD( aLine, LEFT( cRestOfLine, nPointer + 1 ) )
        AADD( aType, '/**/' )
        x += nPointer
      ELSE
        AADD( aLine, cRestOfLine )
        AADD( aType, '/*' )
        EXIT
      ENDIF
    CASE cThisPair == '//' .OR. cThisPair == '&&'
      IF lConvertSlash
        AADD( aLine, '//' + SUBSTR( cThisLine, x + 2 ) )
      ELSE
        AADD( aLine, SUBSTR( cThisLine, x ) )
      ENDIF
      AADD( aType, '//' )
      EXIT
    CASE cThisPair == '*/'
      AADD( aLine, '*/' )
      AADD( aType, '*/' )
      x ++
    CASE cThisPair == '()'
      AADD( aLine, cThisPair )
      AADD( aType, 'O' )
      x ++
    CASE cThisPair == '{}'
      AADD( aLine, cThisPair )
      AADD( aType, 'O' )
      x ++
    CASE cThisPair == '<>'
      AADD( aLine, cThisPair )
      AADD( aType, 'O' )
      x ++
    CASE cThisPair == '<='
      AADD( aLine, cThisPair )
      AADD( aType, 'O' )
      x ++
    CASE cThisPair == '>='
      AADD( aLine, cThisPair )
      AADD( aType, 'O' )
      x ++
    CASE cThisPair == '->'
      AADD( aLine, cThisPair )
      AADD( aType, 'O' )
      x ++
    CASE cThisChar $ '-+/*=?|:' .AND. ATAIL( aLine ) == cThisChar
      aLine[ LEN( aLine ) ] += cThisChar
    CASE cThisChar == '=' .AND. !EMPTY( aLine ) .AND. ATAIL( aLine ) $ '+-/*^:'
      aLine[ LEN( aLine ) ] += cThisChar
    CASE cThisChar $ '-+/*=?|:'
      AADD( aLine, cThisChar )
      AADD( aType, 'O' )  // Operator
    CASE cThisChar == '&'
      AADD( aLine, cThisChar )
      AADD( aType, 'M' )  // Macro
    CASE cThisChar == '\'   //this is not a file slash in linux??
      AADD( aLine, cThisChar )  //might be a problem somewhere??
      AADD( aType, '\' )  // File Slash
    CASE cThisChar == cTab
      AADD( aLine, ' ' )  // Convert Tab to Space for stripping.
      AADD( aType, 'SP' )   //a space type
    OTHERWISE
      AADD( aLine, cThisChar )
      AADD( aType, 'U' )
    ENDCASE

    IF cThisChar $ '-+/*=?|:(,'
      lBrackMode := .T.
    ENDIF

  NEXT x

  nElements := LEN( aLine )

  IF nElements > 0

    IF '.AND.' $ uThisLine

      // check for .and. boolean command imbedded in words

      FOR x := 1 TO nElements
        IF aType[ x ] == 'W' .AND. LEN( aLine[ x ] ) > 5
          DO WHILE LEN( aLine[ x ] ) > 5 .AND. ( nPointer := AT( '.AND.', UPPER( aLine[ x ] ) ) ) > 0

            cLeft  := LEFT( aLine[ x ], nPointer - 1 )
            cRight := SUBSTR( aLine[ x ], nPointer + 5 )

            IF .NOT. EMPTY( cLeft )
              nElements ++
              ASIZE( aLine, nElements )
              ASIZE( aType, nElements )
              AINS( aLine, x )
              AINS( aType, x )
              aLine[ x ] := cLeft
              aType[ x ] := 'W'
              x ++
            ENDIF

            aLine[ x ] := SUBSTR( aLine[ x ], nPointer, 5 )
            aType[ x ] := 'W'   // to be identified later...

            IF .NOT. EMPTY( cRight )
              nElements ++
              x ++
              ASIZE( aLine, nElements )
              ASIZE( aType, nElements )
              AINS( aLine, x )
              AINS( aType, x )
              aLine[ x ] := cRight
              aType[ x ] := 'W'
            ENDIF

          ENDDO
        ENDIF
      NEXT

    ENDIF

    // check for .or. boolean command imbedded in words

    IF '.OR.' $ uThisLine

      nElements := LEN( aLine )
      FOR x := 1 TO nElements
        IF aType[ x ] == 'W' .AND. LEN( aLine[ x ] ) > 4
          DO WHILE LEN( aLine[ x ] ) > 4 .AND. ( nPointer := AT( '.OR.', UPPER( aLine[ x ] ) ) ) > 0

            cLeft  := LEFT( aLine[ x ], nPointer - 1 )
            cRight := SUBSTR( aLine[ x ], nPointer + 4 )

            IF .NOT. EMPTY( cLeft )
              nElements ++
              ASIZE( aLine, nElements )
              ASIZE( aType, nElements )
              AINS( aLine, x )
              AINS( aType, x )
              aLine[ x ] := cLeft
              aType[ x ] := 'W'
              x ++
            ENDIF

            aLine[ x ] := SUBSTR( aLine[ x ], nPointer, 4 )
            aType[ x ] := 'W'   // to be identified later...

            IF .NOT. EMPTY( cRight )
              nElements ++
              x ++
              ASIZE( aLine, nElements )
              ASIZE( aType, nElements )
              AINS( aLine, x )
              AINS( aType, x )
              aLine[ x ] := cRight
              aType[ x ] := 'W'
            ENDIF

          ENDDO
        ENDIF
      NEXT
    ENDIF

    // check for .not. boolean command imbedded in words

    IF '.NOT.' $ uThisLine

      nElements := LEN( aLine )
      FOR x := 1 TO nElements
        IF aType[ x ] == 'W' .AND. LEN( aLine[ x ] ) > 5
          DO WHILE LEN( aLine[ x ] ) > 5 .AND. ( nPointer := AT( '.NOT.', UPPER( aLine[ x ] ) ) ) > 0

            cLeft  := LEFT( aLine[ x ], nPointer - 1 )
            cRight := SUBSTR( aLine[ x ], nPointer + 5 )

            IF .NOT. EMPTY( cLeft )
              nElements ++
              ASIZE( aLine, nElements )
              ASIZE( aType, nElements )
              AINS( aLine, x )
              AINS( aType, x )
              aLine[ x ] := cLeft
              aType[ x ] := 'W'
              x ++
            ENDIF

            aLine[ x ] := SUBSTR( aLine[ x ], nPointer, 5 )
            aType[ x ] := 'W'   // to be identified later...

            IF .NOT. EMPTY( cRight )
              nElements ++
              x ++
              ASIZE( aLine, nElements )
              ASIZE( aType, nElements )
              AINS( aLine, x )
              AINS( aType, x )
              aLine[ x ] := cRight
              aType[ x ] := 'W'
            ENDIF

          ENDDO
        ENDIF
      NEXT

    ENDIF

    // Kill off the space elements in the array

    nElements := LEN( aLine )
    aTemp1    := {}
    aTemp2    := {}
    FOR x := 1 TO nElements
      IF aLine[ x ] <> ' '
        AADD( aTemp1, aLine[ x ] )
        AADD( aTemp2, aType[ x ] )
      ENDIF
    NEXT

    // combine two word commands

    nElements := LEN( aTemp1 ) - 1
    FOR x := 1 TO nElements

      cWord := UPPER( aTemp1[ x ] )

      IF '|' + cWord + '|' $ '|DO|BEGIN|END|SET|CLEAR|COPY STRU|APPEND|LABEL|REPORT|CREATE|DELETE|MENU|RESTORE|SAVE|'

        lAction  := .F.
        cLookFor := UPPER( PAD( aTemp1[ x + 1 ], 4 ) )

        DO CASE
        CASE cWord == 'DO' .AND. cLookFor $ 'WHIL|CASE'   //move lookfor up here 3/06
          lAction := .T.  //3/06 make all other do follow a procedure
        CASE cWord == 'DO' .AND. x = 1 .AND. LEN( aTemp2 ) > 1
          aTemp2[ 2 ] := 'P'  //3/06 add DO P(rocedure) type
        CASE cWord == 'SET' .AND. x = 1 .AND. atemp1[ 2 ] = 'KEY' .AND. LEN( atemp2 ) > 4
          IF atemp2[ 5 ] == 'W'   //test that it isn't a comment
            atemp2[ 5 ] = 'P'   //3/06 add SET KEY procedure tracking
          ENDIF
        CASE cWord == 'BEGIN'
          lAction := cLookFor $ 'SEQU'
        CASE cWord == 'END'
          lAction := cLookFor $ 'CASE|DO  |IF  |SEQU|WHIL'
        CASE cWord == 'SET'   //3/06 added EVENTMASK
          lAction := cLookFor $ 'ALTE|BELL|CENT|COLO|CONF|CONS|CURS|DATE|DECI|DEFA|DELE|DELI|DEVI|EPOC|ESCA|EVEN|EXAC|EXCL|FILT|FIXE|FORM|FUNC|INDE|INTE|KEY |MARG|MESS|ORDE|PATH|PRIN|PROC|RELA|SCOR|SOFT|TYPE|UNIQ|WRAP'
        CASE cWord == 'CLASS'
          lAction := cLookFor $ 'METH|VAR '
        CASE cWord == 'CLEAR'
          lAction := cLookFor $ 'ALL |GETS|MEMO|SCRE|TYPE'
        CASE cWord == 'COPY'
          lAction := cLookFor $ 'FILE|STRU|TO  '
        CASE PAD( cWord, 9 ) == 'COPY STRU'
          lAction := cLookFor == 'EXTE'
        CASE cWord == 'APPEND'
          lAction := cLookFor $ 'BLAN|FROM'
        CASE cWord == 'LABEL'
          lAction := cLookFor == 'FORM'
        CASE cWord == 'REPORT'
          lAction := cLookFor == 'FORM'
        CASE cWord == 'CREATE'
          lAction := cLookFor == 'FROM'
        CASE cWord == 'DELETE'
          lAction := cLookFor == 'FILE'
        CASE cWord == 'MENU'
          lAction := cLookFor == 'TO  '
        CASE cWord == 'RESTORE'
          lAction := cLookFor == 'SCRE'
        CASE cWord == 'SAVE'
          lAction := cLookFor == 'SCRE'
        ENDCASE
        IF lAction
          aTemp1[ x ] += ' ' + aTemp1[ x + 1 ]
          ADEL( aTemp1, x + 1 )
          ADEL( aTemp2, x + 1 )
          ASIZE( aTemp1, nElements )
          ASIZE( aTemp2, nElements )
          nElements --
          aTemp2[ x ] := 'W'
        ENDIF

      ENDIF

    NEXT

    // Now, put a space element in every other position

    nElements := LEN( aTemp1 )
    aLine     := {}
    aType     := {}

    FOR x := 1 TO nElements
      AADD( aLine, aTemp1[ x ] )
      AADD( aType, aTemp2[ x ] )
      IF x < nElements
        AADD( aLine, ' ' )
        AADD( aType, 'SP' )
      ENDIF
    NEXT

    // identify the 'W' and 'U' elements

    nElements := LEN( aLine )

    nParenLevel := 0

    FOR x = 1 TO nElements

      DO CASE
      CASE aType[ x ] = 'P'
        //leave it as set 3/06 adding do procedures
      CASE aType[ x ] == 'W'
        DO CASE
        CASE VAL( aLine[ x ] ) > 0
          aType[ x ] := 'N'
        CASE UPPER( aLine[ x ] ) $ '.AND.|.OR.|.NOT.' .AND. ;
            LEFT( aLine[ x ], 1 ) == '.' .AND. ;
            RIGHT( aLine[ x ], 1 ) == '.'

          aType[ x ] := 'BOOL'
          DO CASE
          CASE cBoolCase == 'UPPER'
            aLine[ x ] := UPPER( aLine[ x ] )
          CASE cBoolCase == 'LOWER'
            aLine[ x ] := LOWER( aLine[ x ] )
          ENDCASE

        CASE nParenLevel == 0 .AND. cmd_list( aLine[ x ], @nPointer )
          aType[ x ] := 'C'
          IF aCmdLogic[ nPointer ]
            aType[ x ] := 'CT'
          ENDIF
          DO CASE
          CASE cComCase == 'UPPER'
            aLine[ x ] := UPPER( aLine[ x ] )
          CASE cComCase == 'LOWER'
            aLine[ x ] := LOWER( aLine[ x ] )
          CASE cComCase == 'PROPER'
            aLine[ x ] := proper( aLine[ x ] )
          CASE cComCase == 'LIKEINFILE'
            aLine[ x ] := TRIM( aCommand[ nPointer ] )
          ENDCASE

        CASE nElements > x + 1 .AND. LEFT( aLine[ x + 2 ], 1 ) == '(' .AND. fnc_list( aLine[ x ], @nPointer )
          aType[ x ] := 'FF'
          // fix 13Dec'98 (DJW): case below was using cComCase instead of cFunCase
          DO CASE
          CASE cFunCase == 'UPPER'
            aLine[ x ] := UPPER( aLine[ x ] )
          CASE cFunCase == 'LOWER'
            aLine[ x ] := LOWER( aLine[ x ] )
          CASE cFunCase == 'PROPER'
            aLine[ x ] := proper( aLine[ x ] )
          CASE cFunCase == 'LIKEINFILE'
            aLine[ x ] := TRIM( aFunction[ nPointer ] )
          ENDCASE

        OTHERWISE
          aType[ x ] := 'V'

        ENDCASE

      CASE aType[ x ] == 'U'

        DO CASE
        CASE aLine[ x ] == ';'
          aType[ x ] := 'LB'

        CASE aLine[ x ] $ '({['
          aType[ x ] := '+'
          nParenLevel ++

        CASE aLine[ x ] $ ')}]'
          aType[ x ] := '-'
          nParenLevel --

        CASE op_list( aLine[ x ] )
          aType[ x ] := 'OP'

        ENDCASE
      ENDCASE
    NEXT x

    //commented this out 3/06 as it was adding a bunch of IF functions to altd()
    //afunclist{} in func_call(), suspect this removal will cause trouble in code
    //the if function/command/operator
    //      if nElements > 0 .and. upper( aLine[ 1 ] ) == 'IF'
    //        aType[ 1 ] := 'F'  //first element of line
    //      endif

    // Identify SET( as a function

    IF UPPER( aLine[ 1 ] ) == 'SET'
      IF LEN( aLine ) > 2
        IF aLine[ 3 ] == '('
          aType[ 1 ] := 'FF'
        ENDIF
      ENDIF
    ENDIF

    // throw away spaces after functions and before parenthesis or brackets

    nElements := LEN( aLine ) - 1

    FOR x := 2 TO nElements

      IF UPPER( aLine[ x ] ) == 'IF'  // any IF after the first element is a function!
        aType[ x ] := 'FF'
      ENDIF

      IF aLine[ x ] == ' ' .AND. ;
                LEFT( aLine[ x + 1 ], 1 ) $ '([' .AND. ;
                aType[ x - 1 ] $ 'FFVC'

        IF LEFT( aLine[ x + 1 ], 1 ) == '('
          IF aType[ x - 1 ] <> 'FF'
            aType[ x - 1 ] := 'F'
          ENDIF
        ENDIF
        ADEL( aLine, x )
        ADEL( aType, x )
        ASIZE( aLine, nElements )
        ASIZE( aType, nElements )
        nElements --
        x --
      ENDIF

    NEXT

    // throw away spaces after macro's

    nElements := LEN( aLine ) - 1

    FOR x := 2 TO nElements
      IF aLine[ x ] == ' ' .AND. aType[ x - 1 ] == 'M'
        ADEL( aLine, x )
        ADEL( aType, x )
        ASIZE( aLine, nElements )
        ASIZE( aType, nElements )
        nElements --
        x --
      ENDIF
    NEXT

    // throw away spaces before commas

    nElements := LEN( aLine ) - 1

    FOR x := 1 TO nElements
      IF aLine[ x ] == ' ' .AND. aLine[ x + 1 ] == ','
        ADEL( aLine, x )
        ADEL( aType, x )
        ASIZE( aLine, nElements )
        ASIZE( aType, nElements )
        nElements --
      ENDIF
    NEXT

    // throw away spaces after ! and @ except:
    //    a. When first element on line starts with !=,
    //    b. When the line starts with @ and lLastContinue

    IF ( aLine[ 1 ] == '!' .AND. aLine[ 3 ] == '=' ) .OR. ;
        ( aLine[ 1 ] == '@' .AND. lLastContinue )
      nStartElem := 1
    ELSE
      nStartElem := 2
    ENDIF

    nElements := LEN( aLine ) - 1

    FOR x := nStartElem TO nElements
      IF ( LEFT( aLine[ x ], 1 ) $ '!@' .OR. aLine[ x ] == '::' ) .AND. ;
          LEFT( aLine[ x + 1 ], 1 ) == ' '
        ADEL( aLine, x + 1 )
        ADEL( aType, x + 1 )
        ASIZE( aLine, nElements )
        ASIZE( aType, nElements )
        nElements --
      ENDIF
    NEXT

    // throw away spaces on both sides of -> and : and \
    // Make into a single element...

    nElements := LEN( aLine ) - 2

    FOR x := 3 TO nElements
      IF aLine[ x ] == '->' .OR. aLine[ x ] $ ':\'
        aLine[ x - 2 ] += aLine[ x ] + aLine[ x + 2 ]
        aType[ x - 2 ] := 'V'
        FOR xx := 1 TO 4
          ADEL( aLine, x - 1 )
          ADEL( aType, x - 1 )
        NEXT
        nElements -= 4
        ASIZE( aLine, nElements + 2 )
        ASIZE( aType, nElements + 2 )
      ENDIF
    NEXT

    // Identify line breaks and line continuations

    nElements := LEN( aLine )

    FOR x := 1 TO nElements
      IF aType[ x ] == 'LB'
        // if a ; (linebreak) is in the last position,
        // it ALWAYS means that the line is continued.
        IF x == nElements
          aType[ x ] := 'LC'
        ENDIF
        IF x == nElements - 2
          IF LEFT( ATAIL( aType ), 1 ) == '/'
            aType[ x ] := 'LC'
          ENDIF
        ENDIF
      ENDIF
    NEXT

    IF LEN( aLine ) > 2 .AND. aLine[ 1 ] == '@' .AND. aLine[ 2 ] == ' ' .AND. LEFT( aLine[ 3 ], 1 ) == ':'
      ADEL( aLine, 2 )
      ADEL( aType, 2 )
      ASIZE( aLine, LEN( aLine ) - 1 )
      ASIZE( aType, LEN( aType ) - 1 )
    ENDIF

    IF lMode5   // this is 5.x specific stuff

      // throw away spaces after >)}] and before : // oo stuff

      nElements := LEN( aLine ) - 2

      FOR x := 1 TO nElements

        IF aType[ x ] $ 'O-' .AND. ;
                  aType[ x + 1 ] == 'SP' .AND. ;
                  aType[ x + 2 ] $ 'F' .AND. ;
                  LEFT( aLine[ x + 2 ], 1 ) == ':'

          ADEL( aLine, x + 1 )
          ADEL( aType, x + 1 )

          ASIZE( aLine, nElements + 1 )
          ASIZE( aType, nElements + 1 )

          nElements --

        ENDIF
      NEXT

      // throw away spaces between ] [

      nElements := LEN( aLine ) - 2

      FOR x := 1 TO nElements

        IF aLine[ x ] == ']' .AND. ;
                  aType[ x + 1 ] == 'SP' .AND. ;
                  aLine[ x + 2 ] = '['

          IF lConvertArray

            aLine[ x ] := ', ' + SUBSTR( aLine[ x + 2 ], 2 )

            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )

            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )

            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )

            nElements -= 2
          ELSE
            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )

            ASIZE( aLine, nElements + 1 )
            ASIZE( aType, nElements + 1 )

            nElements --
          ENDIF

        ENDIF
      NEXT

      // See if this is an assignment beyond position 3 but not
      // surrounded by parenthetic levels  like:
      // x[ 4 ] := .T.  // := in position 8

      IF .NOT. ( LEFT( aType[ 1 ], 1 ) $ 'CF' )

        nParenLevel := 0
        nElements   := LEN( aLine )
        FOR x := 1 TO nElements

          DO CASE
          CASE aType[ x ] == '+'
            nParenLevel ++
          CASE aType[ x ] == '-'
            nParenLevel --
          ENDCASE

          IF nParenLevel == 0 .AND. aLine[ x ] == ':='

            // incorporate all 2 thru x-2 elements into element 1
            // and delete the combined pieces
            // resize the array appropriately

            aType[ 1 ] := 'V'
            FOR xx := 2 TO x - 2
              aLine[ 1 ] += aLine[ xx ]
            NEXT
            FOR xx := 2 TO x - 2
              ADEL( aLine, 2 )
              ADEL( aType, 2 )
              nElements --
            NEXT
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )

            EXIT

          ENDIF

        NEXT

      ENDIF

      // if there is an = in position 3, it must be an assignment!
      // unless it is a continued line

      IF .NOT. lLineContinue

        IF LEN( aLine ) > 2
          IF aLine[ 3 ] == '='
            aLine[ 3 ] := ':='
            aType[ 1 ] := 'V'
          ENDIF
        ENDIF

        // also, the = in a for next is an assignment

        IF LEN( aLine ) > 10
          IF aLine[ 5 ] == '=' .AND. UPPER( aLine[ 1 ] ) == 'FOR'
            aLine[ 5 ] := ':='
            aType[ 3 ] := 'V'
          ENDIF
        ENDIF

      ENDIF

      // If deflate1 is on, throw away spaces after ( and before )
      IF lDeflate1
        nElements := LEN( aLine ) - 1
        FOR x := 1 TO nElements
          IF RIGHT( aLine[ x ], 1 ) == '(' .AND. ;
                   aType[ x + 1 ] == 'SP'
            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
        FOR x := 1 TO nElements
          IF LEFT( aLine[ x + 1 ], 1 ) == ')' .AND. ;
                  aType[ x ] == 'SP'
            ADEL( aLine, x )
            ADEL( aType, x )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
      ENDIF

      // If deflate2 is on, throw away spaces after [ and before ]
      IF lDeflate2
        nElements := LEN( aLine ) - 1
        FOR x := 1 TO nElements
          IF RIGHT( aLine[ x ], 1 ) == '[' .AND. ;
                   aType[ x + 1 ] == 'SP'
            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
        FOR x := 1 TO nElements
          IF LEFT( aLine[ x + 1 ], 1 ) == ']' .AND. ;
                  aType[ x ] == 'SP'
            ADEL( aLine, x )
            ADEL( aType, x )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
      ENDIF

      // If deflate3 is on, throw away spaces after { and before }
      IF lDeflate3
        nElements := LEN( aLine ) - 1
        FOR x := 1 TO nElements
          IF RIGHT( aLine[ x ], 1 ) == '{' .AND. ;
                   aType[ x + 1 ] == 'SP'
            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
        FOR x := 1 TO nElements
          IF LEFT( aLine[ x + 1 ], 1 ) == '}' .AND. ;
                  aType[ x ] == 'SP'
            ADEL( aLine, x )
            ADEL( aType, x )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
      ENDIF

      // If deflate4 is on, throw away spaces after ,
      IF lDeflate4
        nElements := LEN( aLine ) - 1
        FOR x := 1 TO nElements
          IF aLine[ x ] == ',' .AND. ;
                    aType[ x + 1 ] == 'SP'
            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
      ENDIF

      // If deflate5 is on, throw away spaces surrounding +
      IF lDeflate5
        nElements := LEN( aLine ) - 1
        FOR x := 1 TO nElements
          IF aLine[ x ] == '+' .AND. ;
                    aType[ x + 1 ] == 'SP'
            ADEL( aLine, x + 1 )
            ADEL( aType, x + 1 )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
        FOR x := 1 TO nElements
          IF aLine[ x + 1 ] == '+' .AND. ;
                    aType[ x ] == 'SP'
            ADEL( aLine, x )
            ADEL( aType, x )
            ASIZE( aLine, nElements )
            ASIZE( aType, nElements )
            nElements --
          ENDIF
        NEXT
      ENDIF

    ENDIF

    // Identify known assignments as variables.

    nElements := LEN( aLine )

    FOR x := 3 TO nElements
      IF aLine[ x ] == ':='
        aType[ x - 2 ] := 'V'
      ENDIF
    NEXT

  ENDIF

END SEQUENCE
RETURN { aLine, aType }   //function lineparse()



****************************************************************************
STATIC PROCEDURE main_screen( filespec )
****************************************************************************
STATIC cBox := ".-.|'-`| "
nMidScreen := 8 + INT( ( ( MAXROW() - 2 ) - 8 ) / 2 )

SETCOLOR( 'w+/b' )

CLEAR SCREEN

DISPBOX( 0, 0, 8, MAXCOL(), cBox )
DISPBOX( 8, 0, nMidScreen, MAXCOL(), cBox )
DISPBOX( nMidScreen, 0, MAXROW() - 2, MAXCOL(), cBox )
@  8,  0 SAY ''
@  8, MAXCOL() SAY ''
@ nMidScreen,  0 SAY ''
@ nMidScreen, MAXCOL() SAY ''

centertext( ' Click! Clipper Source Code Reformatter,  Version ' + CVERSION + ' ', 0, 'GR+/R' )

centertext( 'Working set: ' + filespec, 2 )

centertext( ' Copyright (C) 1996-98, Phil Barnett. All Rights Reserved Worldwide ', MAXROW() - 2, 'W+/RB' )
RETURN



****************************************************************************
STATIC FUNCTION pop_stack( aStack )
****************************************************************************
LOCAL nLength := LEN( aStack )
LOCAL retval  := ''

IF nLength > 0
  retval := aStack[ nLength ]
  ASIZE( aStack, nLength - 1 )
ENDIF
RETURN retval


****************************************************************************
FUNCTION RootName( FILE_NAME )
****************************************************************************
LOCAL DOTAT := RAT( '.', FILE_NAME )

IF DOTAT > 0
  FILE_NAME := LEFT( FILE_NAME, DOTAT - 1 )
ENDIF
RETURN ALLTRIM( FILE_NAME )


****************************************************************************
PROCEDURE setlinecont( aType )
****************************************************************************
// sets these STATIC variables when called from declbuster.
lLastContinue := lLineContinue
lLineContinue := ASCAN( aType, 'LC' ) > 0
RETURN


****************************************************************************
PROCEDURE show_in( cData )
****************************************************************************
IF lVerbose
  SCROLL( 9, 1, nMidScreen - 1, MAXCOL() - 1, 1 )
  @ nMidScreen - 1, 2 SAY LEFT( cData, MAXCOL() - 4 )
ENDIF

RETURN


****************************************************************************
PROCEDURE show_out( cData, cColor )
****************************************************************************
IF lVerbose
  DEFAULT cColor TO 'W+/B'
  SCROLL( nMidScreen + 1, 1, MAXROW() - 3, MAXCOL() - 1, 1 )
  @ MAXROW() - 3, 2 SAY LEFT( cData, MAXCOL() - 4 ) COLOR cColor
ENDIF
RETURN


****************************************************************************
FUNCTION TabSpStrip( cString )
****************************************************************************
// strips tabs and spaces in any combination from left end of string
LOCAL nPointer := 1
LOCAL TABSPACE := ' ' + CHR( K_TAB )
DO WHILE SUBSTR( cString, nPointer, 1 ) $ TABSPACE
  nPointer ++
ENDDO
RETURN SUBSTR( cString, nPointer )


****************************************************************************
//Added 10/03 for Harbour Linux Conversion
FUNCTION TabStrip( cCharString )
****************************************************************************
LOCAL ii := 1, cFirst := SUBSTR( cCharString, 1, 1 )
DO WHILE SUBSTR( cCharString, ii, 1 ) == CHR( K_TAB )
  ii ++
ENDDO
RETURN SUBSTR( cCharString, ii )


****************************************************************************
//this is last step after initial parsing and smart alignment
STATIC PROCEDURE TheAligner( cInFile, cOutFile, cClickini )
****************************************************************************
LOCAL oBuffObj4    := bInit( cInFile )
LOCAL oHandle
LOCAL nOldPcntDone
LOCAL nPcntDone    := 0
LOCAL cThisLine    := ''
LOCAL cTempLine
LOCAL cThisCommand
LOCAL cNextLine
LOCAL cOutput
LOCAL aLines       := {}
LOCAL aLControl    := {}
LOCAL x
LOCAL y
LOCAL nY

LOCAL aParse
LOCAL aLine      := {}
LOCAL aType      := {}
LOCAL aNextParse
LOCAL aNextLine
LOCAL aNextType
LOCAL aControl   := { '@   ', 'SAY ', 'GET ', 'PICT', 'VALI', ;
  'RANG', 'WHEN', 'COLO', 'SEND', 'MESS' }
LOCAL aOutPut
LOCAL aOutLines
LOCAL aOutMax   := ARRAY( 10 )

LOCAL nNumLines
LOCAL nNumElements
LOCAL nPointer
LOCAL nLastPointer
LOCAL lClickIgnore := .F.
LOCAL nMaxLen
LOCAL nHowmany
LOCAL nShorter
LOCAL nLeadSpace
LOCAL lInDbcre8    := .F.
LOCAL lInDbcre82   := .F.
LOCAL lInClasAlin  := .F.
LOCAL nMaxName
LOCAL nMaxN1
LOCAL nMaxN2
LOCAL lWorking
LOCAL nCommaAt
LOCAL cTabStrip
LOCAL cComment
LOCAL nOffset
LOCAL nOutPad
LOCAL nLineLen
LOCAL lTwoLevel, lbopen

//local cFullPath     := if( file( 'CLICK.INI' ), 'CLICK', RootName( ft_origin() ) ) + '.INI'
LOCAL dbCreateAlign := ProfileString( cClickini, 'CLICK', 'ALIGN_DBCREATE_IN_THE_ALIGNER', 'YES' ) == 'YES'
LOCAL lClassAlign   := ProfileString( cClickini, 'CLICK', 'ALIGN_CLASS_IN_THE_ALIGNER', 'YES' ) == 'YES'

LOCAL cAlignChars := IF( lMode5, ':=|+=|-=|*=|/=|^=|!=', '=|!=' )

lbopen := bOpen( oBuffObj4 )  //must do this first to get crlf setting
FERASE( cOutFile )
oHandle := bo_init( cOutFile,, oBuffObj4[ newline ], cClickini )
IF bo_open( oHandle )
  IF lbopen   //bOpen( oBuffObj4 )
    DO WHILE !bEof( oBuffObj4 )

      lLineContinue := ASCAN( aType, 'LC' ) > 0

      cThisLine := bReadLine( oBuffObj4 )
      @  6, 67 SAY STR( bLineNumber( oBuffObj4 ), 8 )
      show_in( cThisLine )

      nOldPcntDone := nPcntDone
      nPcntDone    := INT( bRelative( oBuffObj4 ) * 50 )
      IF nOldPcntDone <> nPcntDone
        @  6, 14 SAY REPLICATE( '', nPcntDone ) COLOR 'B/B'
      ENDIF

      aParse    := lineparse( LTRIM( cThisLine ) )
      aLine     := aParse[ 1 ]
      aType     := aParse[ 2 ]
      cTabStrip := TabSpStrip( cThisLine )
      nLineLen  := LEN( aLine )
      //IF upper(substr(cthisline,1,7))="COUTDIR"
      //altd()
      //endif
      IF UPPER( cTabStrip ) == '*+CLICKOFF'
        lClickIgnore := .T.
      ENDIF
      IF lClickIgnore
        bo_writeNoDupe( oHandle, cThisLine + oBuffObj4[ newline ] )
        show_out( cThisLine )
        IF UPPER( cTabStrip ) == '*+CLICKON' .OR. bEof( oBuffObj4 )
          lClickIgnore := .F.
        ENDIF
        IF AT( '*/', cThisLine ) > 0
          lCommentMode := .F.
        ENDIF
        LOOP
      ENDIF

      IF LEFT( cTabStrip, 1 ) == '*' .OR. LEFT( cTabStrip, 2 ) $ '//|&&'
        bo_writeNoDupe( oHandle, cThisLine + oBuffObj4[ newline ] )
        show_out( cThisLine )
        IF AT( '*/', cThisLine ) > 0
          lCommentMode := .F.
        ENDIF
        LOOP
      ENDIF

      IF lCommentMode
        IF ( nPointer := AT( '*/', cThisLine ) ) > 0
          nPointer ++

          lCommentMode := .F.
          bo_writeNoDupe( oHandle, LEFT( cThisLine, nPointer ) + oBuffObj4[ newline ] )
          show_out( LEFT( cThisLine, nPointer ) )
          cThisLine := SUBSTR( cThisLine, nPointer + 1 )
          IF .NOT. EMPTY( cThisLine )
            nStripComment := nPointer + 1
          ENDIF
          LOOP
        ELSE
          bo_writeNoDupe( oHandle, cThisLine + oBuffObj4[ newline ] )
          show_out( cThisLine )
          LOOP
        ENDIF
      ELSE
        IF ATAIL( aType ) == '/*'
          lCommentMode := .T.
        ENDIF
      ENDIF

      DO CASE

        // This case aligns CLASS HEADERS
      CASE lClassAlign .AND. ;
          ( ( nLineLen > 2 .AND. UPPER( aLine[ 1 ] ) == 'CREATE' .AND. UPPER( aLine[ 3 ] ) == 'CLASS' ) .OR. ;
          ( nLineLen > 0 .AND. UPPER( aLine[ 1 ] ) == 'CLASS' ) .OR. lInClasAlin )

        AADD( aLines, { leadspace( cThisLine ), LTRIM( cThisLine ), aLine, aType } )

        IF EMPTY( aLine ) .OR. ;
                 ! ( UPPER( aLine[ 1 ] ) == 'ENDCLASS' .OR. ;
                 ( LEN( aLine ) > 2 .AND. UPPER( aLine[ 1 ] ) == 'END' .AND. UPPER( aLine[ 3 ] ) == 'CLASS' ) )
          lInClasAlin := .T.
          LOOP
        ENDIF
        lInClasAlin := .F.

        nNumLines := LEN( aLines )

        lTwoLevel := .F.
        FOR x := 1 TO nNumLines
          IF LEN( aLines[ x, 3 ] ) > 0 .AND. ;
                 RIGHT( aLines[ x, 3, 1 ], 1 ) == ':'
            lTwoLevel := .T.
            EXIT
          ENDIF
        NEXT

        FOR x := 1 TO nNumLines

          nY        := LEN( aLines[ x, 3 ] )
          cTempLine := ''

          IF nY > 0
            FOR y := 1 TO nY
              cTempline += aLines[ x, 3, y ]
            NEXT
          ENDIF

          DO CASE
          CASE x == 1 .OR. x == nNumLines
            aLines[ x, 1 ] := 0
          CASE LEN( aLines[ x, 3 ] ) > 0 .AND. ;
              RIGHT( aLines[ x, 3, 1 ], 1 ) == ':'
            aLines[ x, 1 ] := nTabClass
          OTHERWISE
            aLines[ x, 1 ] := IIF( lTwoLevel, nTabClass * 2, nTabClass )
          ENDCASE

          cTempLine := SPACE( aLines[ x, 1 ] ) + cTempline

          IF ( nPointer := AT( '//', cTempline ) ) > 0
            cComment  := SUBSTR( cTempline, nPointer )
            cTempLine := TRIM( LEFT( cTempline, nPointer - 1 ) )
          ELSE
            cComment := ''
          ENDIF

          cTempLine += SPACE( nComntTab - ( LEN( cTempLine ) % nComntTab ) ) + cComment

          bo_writeNoDupe( oHandle, TRIM( cTempline ) + oBuffObj4[ newline ] )
        NEXT

        aLines := {}

        // This case aligns DBCREATE()
      CASE dbCreateAlign .AND. nLineLen > 0 .AND. ;
          ( UPPER( aLine[ 1 ] ) == 'DBCREATE' .OR. lInDbcre8 )

        AADD( aLines, { leadspace( cThisLine ), LTRIM( cThisLine ), aLine, aType } )

        //cNextLine  := bNextLine( oBuffObj4 )
        //aNextParse := lineparse( ltrim( cNextLine ) )
        //aNextLine  := aNextParse[ 1 ]
        //aNextType  := aNextParse[ 2 ]

        // lLineContinue := ascan( aNextType, 'LC' ) > 0 .or. ascan( aType, 'LC' ) > 0

        IF ASCAN( aType, 'LC' ) > 0
          lInDbcre8 := .T.
          LOOP
        ENDIF
        lInDbcre8 := .F.

        nNumLines := LEN( aLines )

        nMaxName := 0
        nMaxN1   := 0
        nMaxN2   := 0
        nCommaAt := ASCAN( aLines[ 1, 3 ], ',' )
        lWorking := nCommaAt > 0

        IF lWorking

          BEGIN SEQUENCE

            FOR x := 1 TO nNumLines
              IF LEN( aLines[ x, 3 ] ) > IF( x == 1, 20, 12 ) .AND. ;
                     aLines[ x, 3, IF( x == 1, nCommaAt + 2, 1 ) ] == '{' .AND. ;
                     aLines[ x, 3, IF( x == 1, nCommaAt + 4, 1 ) ] == '{'
                nMaxName := MAX( nMaxName, LEN( aLines[ x, 3, IF( x == 1, 11, 3 ) ] ) )
                nMaxN1   := MAX( nMaxN1, LEN( aLines[ x, 3, IF( x == 1, 17, 9 ) ] ) )
                nMaxN2   := MAX( nMaxN2, LEN( aLines[ x, 3, IF( x == 1, 20, 12 ) ] ) )
              ELSE
                lWorking := .F.
                BREAK
              ENDIF
            NEXT

          END SEQUENCE

        ENDIF

        IF lWorking
          FOR x := 1 TO nNumLines
            IF LEN( aLines[ x, 3 ] ) > IF( x == 1, 20, 12 )
              aLines[ x, 3, IF( x == 1, 11, 3 ) ]  := UPPER( PADR( aLines[ x, 3, IF( x == 1, 11, 3 ) ], nMaxName ) )
              aLines[ x, 3, IF( x == 1, 17, 9 ) ]  := PADL( aLines[ x, 3, IF( x == 1, 17, 9 ) ], nMaxN1 )
              aLines[ x, 3, IF( x == 1, 20, 12 ) ] := PADL( aLines[ x, 3, IF( x == 1, 20, 12 ) ], nMaxN2 )
            ENDIF
          NEXT

          aLines[ 1, 3, 4 ] := UPPER( aLines[ 1, 3, 4 ] )
        ENDIF

        FOR x := 1 TO nNumLines
          nY        := LEN( aLines[ x, 3 ] )
          cTempLine := ''
          FOR y := 1 TO nY
            cTempline += aLines[ x, 3, y ]
          NEXT

          bo_writeNoDupe( oHandle, SPACE( aLines[ x, 1 ] ) + cTempline + oBuffObj4[ newline ] )
        NEXT

        aLines := {}

        // This case aligns arrays which contain DBCREATE() data
      CASE dbCreateAlign .AND. nLineLen > 0 .AND. ;
          ( dbc_identify( aType ) .OR. lInDbcre82 )

        AADD( aLines, { leadspace( cThisLine ), LTRIM( cThisLine ), aLine, aType } )

        cNextLine  := bNextLine( oBuffObj4 )
        aNextParse := lineparse( LTRIM( cNextLine ) )
        aNextLine  := aNextParse[ 1 ]
        aNextType  := aNextParse[ 2 ]

        lLineContinue := ASCAN( aNextType, 'LC' ) > 0 .OR. ASCAN( aType, 'LC' ) > 0

        IF lLineContinue
          lInDbcre82 := .T.
          LOOP
        ENDIF
        lInDbcre82 := .F.

        nNumLines := LEN( aLines )

        nMaxName := 0
        nMaxN1   := 0
        nMaxN2   := 0
        lWorking := .T.

        BEGIN SEQUENCE

          FOR x := 1 TO nNumLines
            IF LEN( aLines[ x, 3 ] ) > IF( x == 1, 20, 12 ) .AND. ;
                   aLines[ x, 3, IF( x == 1, 5, 1 ) ] == '{' .AND. ;
                   aLines[ x, 3, IF( x == 1, 7, 1 ) ] == '{'
              nMaxName := MAX( nMaxName, LEN( aLines[ x, 3, IF( x == 1, 9, 3 ) ] ) )
              nMaxN1   := MAX( nMaxN1, LEN( aLines[ x, 3, IF( x == 1, 15, 9 ) ] ) )
              nMaxN2   := MAX( nMaxN2, LEN( aLines[ x, 3, IF( x == 1, 18, 12 ) ] ) )
            ELSE
              lWorking := .F.
              BREAK
            ENDIF
          NEXT

        END SEQUENCE

        IF lWorking
          FOR x := 1 TO nNumLines
            IF LEN( aLines[ x, 3 ] ) > IF( x == 1, 20, 12 )
              aLines[ x, 3, IF( x == 1, 9, 3 ) ]   := UPPER( PADR( aLines[ x, 3, IF( x == 1, 9, 3 ) ], nMaxName ) )
              aLines[ x, 3, IF( x == 1, 15, 9 ) ]  := PADL( aLines[ x, 3, IF( x == 1, 15, 9 ) ], nMaxN1 )
              aLines[ x, 3, IF( x == 1, 18, 12 ) ] := PADL( aLines[ x, 3, IF( x == 1, 18, 12 ) ], nMaxN2 )
            ENDIF
          NEXT

          aLines[ 1, 3, 4 ] := UPPER( aLines[ 1, 3, 4 ] )
        ENDIF

        nOffset := AT( ':=', aLines[ 1, 2 ] ) - AT( ':=', aLines[ 1, 3, 1 ] + aLines[ 1, 3, 2 ] + aLines[ 1, 3, 3 ] )

        FOR x := 1 TO nNumLines
          nY        := LEN( aLines[ x, 3 ] )
          cTempLine := ''
          FOR y := 1 TO nY
            cTempline += aLines[ x, 3, y ]
          NEXT

          bo_writeNoDupe( oHandle, SPACE( aLines[ x, 1 ] - IF( x > 1, nOffset, 0 ) ) + cTempline + oBuffObj4[ newline ] )
        NEXT

        aLines := {}

        // This case aligns @ say gets
      CASE !lLineContinue .AND. nAlignMethod > 0 .AND. nLineLen > 0 .AND. aLine[ 1 ] == '@'

        IF nLineLen > 2 .AND. VAL( aLine[ 3 ] ) < 10 .AND. aLine[ 3 ] $ '9876543210'
          aLine[ 3 ] := ' ' + aLine[ 3 ]
        ENDIF
        IF nLineLen > 5 .AND. VAL( aLine[ 6 ] ) < 10 .AND. aLine[ 6 ] $ '9876543210'
          aLine[ 6 ] := ' ' + aLine[ 6 ]
        ENDIF

        AADD( aLines, { leadspace( cThisLine ), LTRIM( cThisLine ), aLine, aType } )

        cNextLine  := bNextLine( oBuffObj4 )
        aNextParse := lineparse( LTRIM( cNextLine ) )
        aNextLine  := aNextParse[ 1 ]
        aNextType  := aNextParse[ 2 ]

        IF LEN( aNextLine ) > 0 .AND. aNextLine[ 1 ] == '@'
          LOOP
        ENDIF

        nNumLines := LEN( aLines )

        aOutLines := {}
        AFILL( aOutMax, 0 )

        FOR x := 1 TO nNumLines

          aOutPut := ARRAY( 10 )
          AFILL( aOutPut, '' )
          nLastPointer := 1
          nNumElements := LEN( aLines[ x, 3 ] )
          FOR y := 1 TO nNumElements
            IF /*aLines[ x, 4, y ] $ 'CT' .or.*/ PAD( UPPER( aLines[ x, 3, y ] ), 4 ) $ 'SAY |GET |PICT|COLO|WHEN|RANG|VALI'
              cThisCommand := PAD( UPPER( aLines[ x, 3, y ] ), 4 )  // grab the matching command

              // look for it in the control array
              nPointer := ASCAN( aControl, { | a | cThisCommand == a } )

              IF nPointer > 0
                IF nAlignMethod == 1
                  nLastPointer := nPointer
                ELSE
                  nLastPointer ++
                ENDIF
              ENDIF
            ENDIF

            aOutPut[ nLastPointer ] += aLines[ x, 3, y ]

          NEXT

          AADD( aOutLines, ACLONE( aOutPut ) )

        NEXT

        ASIZE( aLControl, nNumLines )
        AFILL( aLControl, .T. )

        FOR x := 1 TO nNumLines
          cTempLine := ''
          FOR y := 2 TO 10
            cTempLine += TRIM( aOutLines[ x, y ] )
          NEXT
          IF EMPTY( cTempLine )
            aLControl[ x ] := .F.
          ELSE
            FOR y := 1 TO 10
              aOutMax[ y ] := MAX( aOutMax[ y ], LEN( TRIM( aOutLines[ x, y ] ) ) + 1 )
            NEXT
          ENDIF
        NEXT

        FOR x := 1 TO nNumLines
          IF aLControl[ x ]
            IF nAlignMethod == 3
              FOR y := 2 TO 10
                IF y == 2
                  cTempline := SPACE( aLines[ x, 1 ] ) + ;
                    aOutLines[ x, 1 ] + ;
                    aOutLines[ x, y ] + ;
                    IIF( !EMPTY( aOutLines[ x, y + 1 ] ), ';', '' )
                  bo_writeNoDupe( oHandle, cTempline + oBuffObj4[ newline ] )
                  show_out( cTempLine )
                ELSE
                  IF .NOT. EMPTY( aOutLines[ x, y ] )
                    cTempline := SPACE( aLines[ x, 1 ] ) + ;
                      SPACE( LEN( aOutLines[ x, 1 ] ) ) + ;
                      aOutLines[ x, y ] + ;
                      IIF( x < 10 .AND. !EMPTY( aOutLines[ x, y + 1 ] ), ';', '' )
                    bo_writeNoDupe( oHandle, cTempline + oBuffObj4[ newline ] )
                    show_out( cTempLine )
                  ENDIF
                ENDIF
              NEXT
            ELSE
              cTempLine := ''
              FOR y := 1 TO 10
                cTempLine += PAD( aOutLines[ x, y ], aOutMax[ y ] )
              NEXT
              bo_writeNoDupe( oHandle, SPACE( aLines[ x, 1 ] ) + cTempLine + oBuffObj4[ newline ] )
              show_out( SPACE( aLines[ x, 1 ] ) + cTempLine )
            ENDIF
          ELSE
            bo_writeNoDupe( oHandle, SPACE( aLines[ x, 1 ] ) + aLines[ x, 2 ] + oBuffObj4[ newline ] )
            show_out( SPACE( aLines[ x, 1 ] ) + aLines[ x, 2 ] )
          ENDIF
        NEXT

        aLines    := {}
        aOutLines := {}

        // This case aligns assignments
      CASE !lLineContinue .AND. nLineLen > 2 .AND. ;
          PAD( aLine[ 3 ], 2 ) $ cAlignChars

        AADD( aLines, { leadspace( cThisLine ), LTRIM( cThisLine ), aLine, aType, AT( aLine[ 3 ], cThisLine ) } )

        cNextLine  := bNextLine( oBuffObj4 )
        aNextParse := lineparse( LTRIM( cNextLine ) )
        aNextLine  := aNextParse[ 1 ]
        aNextType  := aNextParse[ 2 ]

        IF LEN( aNextLine ) > 2 .AND. ;
               PAD( aNextLine[ 3 ], 2 ) $ cAlignChars .AND. ;
               ! ASCAN( aType, 'LC' ) > 0
          LOOP
        ENDIF

        nNumLines := LEN( aLines )
        aOutLines := {}
        nMaxLen   := 0

        FOR x := 1 TO nNumLines
          nMaxLen := MAX( LEN( aLines[ x, 3, 1 ] ), nMaxLen )
        NEXT

        nMaxLen += 1

        FOR x := 1 TO nNumLines
          aLines[ x, 3, 2 ] := SPACE( nMaxLen - LEN( aLines[ x, 3, 1 ] ) )

          aLines[ x, 2 ] := ''
          nHowMany       := LEN( aLines[ x, 3 ] )
          cComment       := ''
          FOR y := 1 TO nHowMany
            IF aLines[ x, 4, y ] == '//'
              cComment := aLines[ x, 3, y ]
            ELSE
              aLines[ x, 2 ] += aLines[ x, 3, y ]
            ENDIF
          NEXT

          cOutput := SPACE( aLines[ x, 1 ] ) + aLines[ x, 2 ]

          IF .NOT. EMPTY( cComment )
            cOutput += SPACE( nComntTab - ( LEN( cOutput ) % nComntTab ) ) + cComment
          ENDIF

          bo_writeNoDupe( oHandle, cOutput + oBuffObj4[ newline ] )
          show_out( SPACE( aLines[ x, 1 ] ) + aLines[ x, 2 ] )
        NEXT

        // was the last line continued?
        IF ASCAN( aLines[ nNumLines, 4 ], 'LC' ) > 0
          nShorter := aLines[ nNumLines, 5 ] - AT( aLines[ nNumLines, 3, 3 ], SPACE( aLines[ nNumLines, 1 ] ) + aLines[ nNumLines, 2 ] )

          nShorter ++

          DO WHILE .T.

            cThisLine := bReadLine( oBuffObj4 )
            @  6, 67 SAY STR( bLineNumber( oBuffObj4 ), 8 )
            show_in( cThisLine )

            nLeadSpace := leadspace( cThisLine )
            /*3/06 Following code sometimes overides the indentation
                    set by INDENT_CONTINUE_LINE option added to the smart allignment 
                    section.  The original intent vs a fixed indent really depends coding
                    style and/or the design intent of Click.  Will just leave this
                    waiting for someone with a better plan,PS
                  */

            DO CASE
            CASE nLeadSpace > nShorter .AND. nShorter < 0
              cOutput := SPACE( ABS( nShorter ) + 1 ) + cThisLine
            CASE nLeadSpace > nShorter
              cOutput := SUBSTR( cThisLine, nShorter )
            OTHERWISE
              cOutput := cThisLine
            ENDCASE

            /*
                  Until I can figure out how to align comments here, I
                  will not mess with them.(Phil comment)

                  if ( nPointer := rat( '//', cOutput ) ) > 0
                     cLeft   := trim( left( cOutput, nPointer - 1 ) )
                     cRight  := substr( cOutput, nPointer )
                     cOutput := cLeft + space( nComntTab - ( len( cLeft ) % nComntTab ) ) + cRight
                  endif
                  */

            bo_writeNoDupe( oHandle, cOutput + oBuffObj4[ newline ] )
            show_out( cOutput )

            aParse := lineparse( LTRIM( cThisLine ) )
            aLine  := aParse[ 1 ]
            aType  := aParse[ 2 ]
            IF ASCAN( aType, 'LC' ) == 0  // no more continues
              EXIT
            ENDIF

          ENDDO
        ENDIF

        aLines    := {}
        aOutLines := {}

        // this case aligns declarations.
      CASE !lLineContinue .AND. nLineLen > 0 .AND. ;
          aType[ 1 ] $ 'CT' .AND. ;
          UPPER( PAD( aLine[ 1 ], 4 ) ) $ 'LOCA|STAT|PUBL|PRIV|MEMV|FIEL'

        AADD( aLines, { leadspace( cThisLine ), LTRIM( cThisLine ), aLine, aType, AT( aLine[ 3 ], cThisLine ) } )

        cNextLine  := bNextLine( oBuffObj4 )
        aNextParse := lineparse( LTRIM( cNextLine ) )
        aNextLine  := aNextParse[ 1 ]
        aNextType  := aNextParse[ 2 ]

        IF LEN( aNextLine ) > 0 .AND. ;
               aNextType[ 1 ] $ 'CT' .AND. ;
               UPPER( PAD( aNextLine[ 1 ], 4 ) ) $ 'LOCA|STAT|PUBL|PRIV|MEMV|FIEL'
          LOOP
        ENDIF

        nNumLines := LEN( aLines )
        aOutLines := {}
        nMaxLen   := 0

        FOR x := 1 TO nNumLines
          nMaxLen := MAX( LEN( aLines[ x, 3, 1 ] + aLines[ x, 3, 2 ] + aLines[ x, 3, 3 ] ), nMaxLen )
        NEXT

        nMaxLen += 1

        FOR x := 1 TO nNumLines
          IF LEN( aLines[ x, 3 ] ) > 4 .AND. aLines[ x, 3, 5 ] == ':='
            aLines[ x, 3, 4 ] := SPACE( nMaxLen - LEN( aLines[ x, 3, 1 ] + aLines[ x, 3, 2 ] + aLines[ x, 3, 3 ] ) )
          ENDIF

          aLines[ x, 2 ] := ''
          nHowMany       := LEN( aLines[ x, 3 ] )
          FOR y = 1 TO nHowMany
            IF aLines[ x, 4, y ] == '//'
              nOutPad        := LEN( aLines[ x, 2 ] )
              nOutPad        += nComntTab - ( nOutPad % nComntTab )
              aLines[ x, 2 ] := PAD( aLines[ x, 2 ], nOutPad ) + aLines[ x, 3, y ]
            ELSE
              alines[ x, 2 ] += aLines[ x, 3, y ]
            ENDIF
          NEXT y

          bo_writeNoDupe( oHandle, SPACE( aLines[ x, 1 ] ) + aLines[ x, 2 ] + oBuffObj4[ newline ] )
          show_out( SPACE( aLines[ x, 1 ] ) + aLines[ x, 2 ] )
        NEXT

        *---------------------------------------------------------------------------
        * was the last line continued?
        *---------------------------------------------------------------------------
        IF ASCAN( aLines[ nNumLines, 4 ], 'LC' ) > 0
          nShorter := aLines[ nNumLines, 5 ] - AT( aLines[ nNumLines, 3, 3 ], SPACE( aLines[ nNumLines, 1 ] ) + aLines[ nNumLines, 2 ] )

          nShorter ++

          DO WHILE .T.
            cThisLine := bReadLine( oBuffObj4 )
            @  6, 67 SAY STR( bLineNumber( oBuffObj4 ), 8 )
            show_in( cThisLine )
            IF leadspace( cThisLine ) > nShorter
              bo_writeNoDupe( oHandle, SUBSTR( cThisLine, nShorter ) + oBuffObj4[ newline ] )
              show_out( SUBSTR( cThisLine, nShorter ) )
            ELSE
              bo_writeNoDupe( oHandle, cThisLine + oBuffObj4[ newline ] )
              show_out( cThisLine )
            ENDIF

            aParse := lineparse( LTRIM( cThisLine ) )
            aLine  := aParse[ 1 ]
            aType  := aParse[ 2 ]
            IF ASCAN( aType, 'LC' ) == 0  // no more continues
              EXIT
            ENDIF

          ENDDO
        ENDIF

        aLines    := {}
        aOutLines := {}

      OTHERWISE
        bo_writeNoDupe( oHandle, cThisLine + oBuffObj4[ newline ] )
        show_out( cThisLine )
      END CASE

    ENDDO

  ENDIF

  bClose( oBuffObj4 )

  bo_close( oHandle )

ENDIF
RETURN  //TheAligner
